diff --git a/src/blockchain_fmt_plug.c b/src/blockchain_fmt_plug.c
index f65105450e..e23451cd1f 100644
--- a/src/blockchain_fmt_plug.c
+++ b/src/blockchain_fmt_plug.c
@@ -26,9 +26,6 @@ john_register_one(&fmt_blockchain);
 
 #ifdef _OPENMP
 #include <omp.h>
-#ifndef OMP_SCALE
-#define OMP_SCALE               4  // this is a slow format
-#endif
 #endif
 
 #include "arch.h"
@@ -60,7 +57,11 @@ john_register_one(&fmt_blockchain);
 #define MAX_KEYS_PER_CRYPT      SSE_GROUP_SZ_SHA1
 #else
 #define MIN_KEYS_PER_CRYPT      1
-#define MAX_KEYS_PER_CRYPT      1
+#define MAX_KEYS_PER_CRYPT      64
+#endif
+
+#ifndef OMP_SCALE
+#define OMP_SCALE               32 // MKPC & scale tuned for i7
 #endif
 
 static char (*saved_key)[PLAINTEXT_LENGTH + 1];
@@ -70,9 +71,8 @@ static struct custom_salt *cur_salt;
 
 static void init(struct fmt_main *self)
 {
-#if defined (_OPENMP)
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	saved_key = mem_calloc_align(sizeof(*saved_key),
 			self->params.max_keys_per_crypt, MEM_ALIGN_WORD);
 	cracked = mem_calloc_align(sizeof(*cracked),
@@ -94,22 +94,23 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 {
 	const int count = *pcount;
 	int index;
+
 #ifdef _OPENMP
 #pragma omp parallel for
 #endif
-	for (index = 0; index < count; index += MAX_KEYS_PER_CRYPT) {
+	for (index = 0; index < count; index += MIN_KEYS_PER_CRYPT) {
 #ifdef SIMD_COEF_32
-		unsigned char master[MAX_KEYS_PER_CRYPT][32];
-		int lens[MAX_KEYS_PER_CRYPT], i;
-		unsigned char *pin[MAX_KEYS_PER_CRYPT], *pout[MAX_KEYS_PER_CRYPT];
-		for (i = 0; i < MAX_KEYS_PER_CRYPT; ++i) {
+		unsigned char master[MIN_KEYS_PER_CRYPT][32];
+		int lens[MIN_KEYS_PER_CRYPT], i;
+		unsigned char *pin[MIN_KEYS_PER_CRYPT], *pout[MIN_KEYS_PER_CRYPT];
+		for (i = 0; i < MIN_KEYS_PER_CRYPT; ++i) {
 			lens[i] = strlen(saved_key[i+index]);
 			pin[i] = (unsigned char*)saved_key[i+index];
 			pout[i] = master[i];
 		}
 		pbkdf2_sha1_sse((const unsigned char **)pin, lens,
 			cur_salt->data, 16, cur_salt->iter, pout, 32, 0);
-		for (i = 0; i < MAX_KEYS_PER_CRYPT; ++i) {
+		for (i = 0; i < MIN_KEYS_PER_CRYPT; ++i) {
 			if (blockchain_decrypt(master[i], cur_salt->data) == 0)
 				cracked[i+index] = 1;
 			else
diff --git a/src/clipperz_srp_fmt_plug.c b/src/clipperz_srp_fmt_plug.c
index db7ec1dcbb..2d71a12ae2 100644
--- a/src/clipperz_srp_fmt_plug.c
+++ b/src/clipperz_srp_fmt_plug.c
@@ -61,11 +61,6 @@ john_register_one(&fmt_clipperz);
 #endif
 
 #include <string.h>
-#include "sha2.h"
-#include "arch.h"
-#include "params.h"
-#include "common.h"
-#include "formats.h"
 #ifdef HAVE_LIBGMP
 #if HAVE_GMP_GMP_H
 #include <gmp/gmp.h>
@@ -77,14 +72,18 @@ john_register_one(&fmt_clipperz);
 #include <openssl/bn.h>
 #define EXP_STR " oSSL-exp"
 #endif
-#include "johnswap.h"
+
 #ifdef _OPENMP
 #include <omp.h>
-#ifndef OMP_SCALE
-#define OMP_SCALE               64
-#endif
 #endif
 
+#include "sha2.h"
+#include "arch.h"
+#include "params.h"
+#include "common.h"
+#include "formats.h"
+#include "johnswap.h"
+
 #define FORMAT_LABEL		"Clipperz"
 #define FORMAT_NAME		"SRP"
 #define ALGORITHM_NAME		"SHA256 32/" ARCH_BITS_STR EXP_STR
@@ -104,8 +103,12 @@ john_register_one(&fmt_clipperz);
 #define SALT_ALIGN		1
 #define USERNAMELEN             32
 
+#ifndef OMP_SCALE
+#define OMP_SCALE               256 // MKPC & scale tuned for i7
+#endif
+
 #define MIN_KEYS_PER_CRYPT	1
-#define MAX_KEYS_PER_CRYPT	4
+#define MAX_KEYS_PER_CRYPT	2
 
 #define SZ 				128
 
@@ -145,9 +148,9 @@ static int max_keys_per_crypt;
 static void init(struct fmt_main *self)
 {
 	int i;
-#if defined (_OPENMP)
+
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	saved_key = mem_calloc_align(sizeof(*saved_key),
 			self->params.max_keys_per_crypt, MEM_ALIGN_WORD);
 	crypt_out = mem_calloc_align(sizeof(*crypt_out), self->params.max_keys_per_crypt, MEM_ALIGN_WORD);
diff --git a/src/dahua_fmt_plug.c b/src/dahua_fmt_plug.c
index 33d4bf0220..977b306b61 100644
--- a/src/dahua_fmt_plug.c
+++ b/src/dahua_fmt_plug.c
@@ -26,13 +26,6 @@ john_register_one(&fmt_dahua);
 
 #ifdef _OPENMP
 #include <omp.h>
-#ifndef OMP_SCALE
-#ifdef __MIC__
-#define OMP_SCALE 512
-#else
-#define OMP_SCALE 32768		// tuned K8-dual HT
-#endif // __MIC__
-#endif // OMP_SCALE
 #endif // _OPENMP
 
 #include "arch.h"
@@ -57,7 +50,15 @@ john_register_one(&fmt_dahua);
 #define SALT_SIZE               0
 #define SALT_ALIGN              1
 #define MIN_KEYS_PER_CRYPT      1
-#define MAX_KEYS_PER_CRYPT      1
+#define MAX_KEYS_PER_CRYPT      64
+
+#ifndef OMP_SCALE
+#ifdef __MIC__
+#define OMP_SCALE 32
+#else
+#define OMP_SCALE 16		// MKPC & scale tuned for i7
+#endif // __MIC__
+#endif // OMP_SCALE
 
 static struct fmt_tests tests[] = {
 	{"$dahua$4WzwxXxM", "888888"},  // from hashcat.net
@@ -75,9 +76,8 @@ static uint32_t (*crypt_out)[BINARY_SIZE / sizeof(uint32_t)];
 
 static void init(struct fmt_main *self)
 {
-#ifdef _OPENMP
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	saved_key = mem_calloc(self->params.max_keys_per_crypt,
 	                       sizeof(*saved_key));
 	saved_len = mem_calloc(self->params.max_keys_per_crypt,
diff --git a/src/django_fmt_plug.c b/src/django_fmt_plug.c
index c0466a962d..94b0e8ec4a 100644
--- a/src/django_fmt_plug.c
+++ b/src/django_fmt_plug.c
@@ -34,9 +34,6 @@ john_register_one(&fmt_django);
 
 #ifdef _OPENMP
 #include <omp.h>
-#ifndef OMP_SCALE
-#define OMP_SCALE               4 // tuned on core i7
-#endif
 #endif
 
 #include "arch.h"
@@ -70,10 +67,14 @@ john_register_one(&fmt_django);
 
 #ifdef SIMD_COEF_32
 #define MIN_KEYS_PER_CRYPT      SSE_GROUP_SZ_SHA256
-#define MAX_KEYS_PER_CRYPT      SSE_GROUP_SZ_SHA256
+#define MAX_KEYS_PER_CRYPT      (1 * SSE_GROUP_SZ_SHA256)
 #else
 #define MIN_KEYS_PER_CRYPT      1
-#define MAX_KEYS_PER_CRYPT      1
+#define MAX_KEYS_PER_CRYPT      8
+#endif
+
+#ifndef OMP_SCALE
+#define OMP_SCALE               2 // MKPC & scale tuned for i7
 #endif
 
 static struct fmt_tests django_tests[] = {
@@ -97,9 +98,8 @@ static struct custom_salt {
 
 static void init(struct fmt_main *self)
 {
-#ifdef _OPENMP
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	saved_key = mem_calloc_align(sizeof(*saved_key),
 			self->params.max_keys_per_crypt, MEM_ALIGN_WORD);
 	crypt_out = mem_calloc_align(sizeof(*crypt_out), self->params.max_keys_per_crypt, MEM_ALIGN_WORD);
@@ -198,15 +198,15 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 #ifdef _OPENMP
 #pragma omp parallel for
 #endif
-	for (index = 0; index < count; index += MAX_KEYS_PER_CRYPT) {
+	for (index = 0; index < count; index += MIN_KEYS_PER_CRYPT) {
 #ifdef SIMD_COEF_32
-		int lens[MAX_KEYS_PER_CRYPT], i;
-		unsigned char *pin[MAX_KEYS_PER_CRYPT];
+		int lens[MIN_KEYS_PER_CRYPT], i;
+		unsigned char *pin[MIN_KEYS_PER_CRYPT];
 		union {
-			uint32_t *pout[MAX_KEYS_PER_CRYPT];
+			uint32_t *pout[MIN_KEYS_PER_CRYPT];
 			unsigned char *poutc;
 		} x;
-		for (i = 0; i < MAX_KEYS_PER_CRYPT; ++i) {
+		for (i = 0; i < MIN_KEYS_PER_CRYPT; ++i) {
 			lens[i] = strlen(saved_key[i+index]);
 			pin[i] = (unsigned char*)saved_key[i+index];
 			x.pout[i] = crypt_out[i+index];
diff --git a/src/dmg_fmt_plug.c b/src/dmg_fmt_plug.c
index 6519cdfbe9..b7a4a88914 100644
--- a/src/dmg_fmt_plug.c
+++ b/src/dmg_fmt_plug.c
@@ -60,13 +60,15 @@ john_register_one(&fmt_dmg);
 #include <stdint.h>
 #include <sys/types.h>
 #include <openssl/des.h>
-#include "aes.h"
-#include "hmac_sha.h"
+#ifdef DMG_DEBUG
+#include <sys/file.h>
+#if (!AC_BUILT || HAVE_UNISTD_H) && !_MSC_VER
+#include <unistd.h>
+#endif
+#endif
+
 #ifdef _OPENMP
 #include <omp.h>
-#ifndef OMP_SCALE
-#define OMP_SCALE               64
-#endif
 #endif
 
 #ifdef DMG_DEBUG
@@ -74,6 +76,8 @@ john_register_one(&fmt_dmg);
 #include "os.h"
 #endif
 #include "arch.h"
+#include "aes.h"
+#include "hmac_sha.h"
 #include "jumbo.h"
 #include "params.h"
 #include "johnswap.h"
@@ -81,12 +85,6 @@ john_register_one(&fmt_dmg);
 #include "formats.h"
 #include "dmg_common.h"
 #include "pbkdf2_hmac_sha1.h"
-#ifdef DMG_DEBUG
-#include <sys/file.h>
-#if (!AC_BUILT || HAVE_UNISTD_H) && !_MSC_VER
-#include <unistd.h>
-#endif
-#endif
 #include "loader.h"
 
 #define FORMAT_LABEL        "dmg"
@@ -113,6 +111,10 @@ john_register_one(&fmt_dmg);
 #define MAX_KEYS_PER_CRYPT  1
 #endif
 
+#ifndef OMP_SCALE
+#define OMP_SCALE           1 // MKPC and scale tuned for i7
+#endif
+
 #undef HTONL
 #define HTONL(n) (((((unsigned long)(n) & 0xFF)) << 24) | \
 		((((unsigned long)(n) & 0xFF00)) << 8) | \
@@ -144,9 +146,8 @@ static struct custom_salt {
 
 static void init(struct fmt_main *self)
 {
-#if defined (_OPENMP)
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	saved_key = mem_calloc_align(sizeof(*saved_key),
 			self->params.max_keys_per_crypt, MEM_ALIGN_WORD);
 	cracked = mem_calloc_align(sizeof(*cracked),
diff --git a/src/dragonfly3_fmt_plug.c b/src/dragonfly3_fmt_plug.c
index 06c3504f71..33818a5e2b 100644
--- a/src/dragonfly3_fmt_plug.c
+++ b/src/dragonfly3_fmt_plug.c
@@ -52,10 +52,10 @@ john_register_one(&fmt_dragonfly3_64);
 #define SALT_ALIGN			1
 
 #define MIN_KEYS_PER_CRYPT		1
-#define MAX_KEYS_PER_CRYPT		1024
+#define MAX_KEYS_PER_CRYPT		64
 
 #ifndef OMP_SCALE
-#define OMP_SCALE			2  // Tuned w/ MKPC for core i7
+#define OMP_SCALE			4  // Tuned w/ MKPC for core i7
 #endif
 
 static struct fmt_tests tests_32[] = {
@@ -89,9 +89,8 @@ static int salt_len;
 
 static void init(struct fmt_main *self)
 {
-#ifdef _OPENMP
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	saved_len = mem_calloc(self->params.max_keys_per_crypt,
 	                       sizeof(*saved_len));
 	saved_key = mem_calloc(self->params.max_keys_per_crypt,
diff --git a/src/drupal7_fmt_plug.c b/src/drupal7_fmt_plug.c
index 38a21219ad..0970e77609 100644
--- a/src/drupal7_fmt_plug.c
+++ b/src/drupal7_fmt_plug.c
@@ -21,22 +21,17 @@ extern struct fmt_main fmt_drupal7;
 john_register_one(&fmt_drupal7);
 #else
 
-#include "sha2.h"
+#ifdef _OPENMP
+#include <omp.h>
+#endif
 
+#include "sha2.h"
 #include "arch.h"
 #include "misc.h"
 #include "common.h"
 #include "formats.h"
 #include "johnswap.h"
 #include "simd-intrinsics.h"
-
-#ifdef _OPENMP
-#include <omp.h>
-#ifndef OMP_SCALE
-#define OMP_SCALE			8
-#endif
-#endif
-
 #include "drupal7_common.h"
 
 #define FORMAT_LABEL			"Drupal7"
@@ -49,6 +44,10 @@ john_register_one(&fmt_drupal7);
 #define BINARY_SIZE			(258/8) // ((258+7)/8)
 #define BINARY_ALIGN			4
 
+#ifndef OMP_SCALE
+#define OMP_SCALE			1
+#endif
+
 #ifdef SIMD_COEF_64
 #define MIN_KEYS_PER_CRYPT      (SIMD_COEF_64*SIMD_PARA_SHA512)
 #define MAX_KEYS_PER_CRYPT      (SIMD_COEF_64*SIMD_PARA_SHA512)
@@ -59,7 +58,7 @@ john_register_one(&fmt_drupal7);
 #endif
 #else
 #define MIN_KEYS_PER_CRYPT		1
-#define MAX_KEYS_PER_CRYPT		1
+#define MAX_KEYS_PER_CRYPT		2
 #endif
 
 /*
@@ -78,9 +77,8 @@ static char (*crypt_key)[DIGEST_SIZE];
 
 static void init(struct fmt_main *self)
 {
-#if defined (_OPENMP)
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	EncKey    = mem_calloc(self->params.max_keys_per_crypt,
 	                       sizeof(*EncKey));
 	EncKeyLen = mem_calloc(self->params.max_keys_per_crypt,
@@ -136,19 +134,20 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 {
 	const int count = *pcount;
 	int index;
+
 #ifdef _OPENMP
 #pragma omp parallel for
 #endif
-	for (index = 0; index < count; index+=MAX_KEYS_PER_CRYPT) {
+	for (index = 0; index < count; index+=MIN_KEYS_PER_CRYPT) {
 #ifdef SIMD_COEF_64
-		unsigned char _IBuf[128*MAX_KEYS_PER_CRYPT+MEM_ALIGN_CACHE], *keys;
+		unsigned char _IBuf[128*MIN_KEYS_PER_CRYPT+MEM_ALIGN_CACHE], *keys;
 		uint64_t *keys64;
 		unsigned i, j, len, Lcount = loopCnt;
 
 		keys = (unsigned char*)mem_align(_IBuf, MEM_ALIGN_CACHE);
 		keys64 = (uint64_t*)keys;
-		memset(keys, 0, 128*MAX_KEYS_PER_CRYPT);
-		for (i = 0; i < MAX_KEYS_PER_CRYPT; ++i) {
+		memset(keys, 0, 128*MIN_KEYS_PER_CRYPT);
+		for (i = 0; i < MIN_KEYS_PER_CRYPT; ++i) {
 			len = EncKeyLen[index+i];
 			for (j = 0; j < 8; ++j)
 				keys[GETPOS(j, i)] = cursalt[j];
@@ -158,7 +157,7 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 			keys64[15*SIMD_COEF_64+(i&(SIMD_COEF_64-1))+i/SIMD_COEF_64*SHA_BUF_SIZ*SIMD_COEF_64] = (len+8) << 3;
 		}
 		SIMDSHA512body(keys, keys64, NULL, SSEi_MIXED_IN|SSEi_OUTPUT_AS_INP_FMT);
-		for (i = 0; i < MAX_KEYS_PER_CRYPT; ++i) {
+		for (i = 0; i < MIN_KEYS_PER_CRYPT; ++i) {
 			len = EncKeyLen[index+i];
 			for (j = 0; j < len; ++j)
 				keys[GETPOS(j+64, i)] = EncKey[index+i][j];
diff --git a/src/electrum_fmt_plug.c b/src/electrum_fmt_plug.c
index 80afd917b8..8e75ccf80a 100644
--- a/src/electrum_fmt_plug.c
+++ b/src/electrum_fmt_plug.c
@@ -24,13 +24,11 @@ john_register_one(&fmt_electrum);
 
 #include <string.h>
 #include <zlib.h>
+#include <openssl/bn.h>
+
 #ifdef _OPENMP
 #include <omp.h>
-#ifndef OMP_SCALE
-#define OMP_SCALE               4
 #endif
-#endif
-#include <openssl/bn.h>
 
 #include "misc.h"
 #include "common.h"
@@ -60,12 +58,17 @@ john_register_one(&fmt_electrum);
 #define SALT_SIZE               sizeof(struct custom_salt)
 #define SALT_ALIGN              sizeof(uint32_t)
 #define PLAINTEXT_LENGTH        125
+
+#ifndef OMP_SCALE
+#define OMP_SCALE               8
+#endif
+
 #ifdef SIMD_COEF_64
 #define MIN_KEYS_PER_CRYPT      SSE_GROUP_SZ_SHA512
 #define MAX_KEYS_PER_CRYPT      SSE_GROUP_SZ_SHA512
 #else
 #define MIN_KEYS_PER_CRYPT      1
-#define MAX_KEYS_PER_CRYPT      1
+#define MAX_KEYS_PER_CRYPT      512
 #endif
 
 static struct fmt_tests electrum_tests[] = {
@@ -108,9 +111,8 @@ static struct custom_salt {
 
 static void init(struct fmt_main *self)
 {
-#ifdef _OPENMP
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	saved_key = mem_calloc(sizeof(*saved_key), self->params.max_keys_per_crypt);
 	cracked = mem_calloc(sizeof(*cracked), self->params.max_keys_per_crypt);
 	cracked_count = self->params.max_keys_per_crypt;
@@ -248,17 +250,17 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 #ifdef _OPENMP
 #pragma omp parallel for
 #endif
-	for (index = 0; index < count; index += MAX_KEYS_PER_CRYPT) {
+	for (index = 0; index < count; index += MIN_KEYS_PER_CRYPT) {
 		unsigned char iv[16];
 		unsigned char key[32];
 		SHA256_CTX ctx;
 		AES_KEY aes_decrypt_key;
 		int extra;
-		unsigned char static_privkey[MAX_KEYS_PER_CRYPT][64];
+		unsigned char static_privkey[MIN_KEYS_PER_CRYPT][64];
 		int i, j;
 
 		if (cur_salt->type == 1 || cur_salt->type == 2 || cur_salt->type == 3) {
-			for (i = 0; i < MAX_KEYS_PER_CRYPT; i++) {
+			for (i = 0; i < MIN_KEYS_PER_CRYPT; i++) {
 				unsigned char outbuf[48] = { 0 };
 
 				SHA256_Init(&ctx);
@@ -318,9 +320,9 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 			SHA512_CTX md_ctx;
 			int shared_pubkeylen= 33;
 #ifdef SIMD_COEF_64
-			int len[MAX_KEYS_PER_CRYPT];
-			unsigned char *pin[MAX_KEYS_PER_CRYPT], *pout[MAX_KEYS_PER_CRYPT];
-			for (i = 0; i < MAX_KEYS_PER_CRYPT; ++i) {
+			int len[MIN_KEYS_PER_CRYPT];
+			unsigned char *pin[MIN_KEYS_PER_CRYPT], *pout[MIN_KEYS_PER_CRYPT];
+			for (i = 0; i < MIN_KEYS_PER_CRYPT; ++i) {
 				len[i] = strlen(saved_key[i+index]);
 				pin[i] = (unsigned char*)saved_key[i+index];
 				pout[i] = static_privkey[i];
@@ -328,14 +330,14 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 			pbkdf2_sha512_sse((const unsigned char **)pin, len, (unsigned char*)"", 0, 1024, pout, 64, 0);
 #else
 
-			for (i = 0; i < MAX_KEYS_PER_CRYPT; i++) {
+			for (i = 0; i < MIN_KEYS_PER_CRYPT; i++) {
 				pbkdf2_sha512((unsigned char *)saved_key[index+i],
 						strlen(saved_key[index+i]),
 						(unsigned char*)"", 0, 1024,
 						static_privkey[i], 64, 0);
 			}
 #endif
-			for (i = 0; i < MAX_KEYS_PER_CRYPT; i++) {
+			for (i = 0; i < MIN_KEYS_PER_CRYPT; i++) {
 				// do static_privkey % GROUP_ORDER
 				p = BN_bin2bn(static_privkey[i], 64, NULL);
 				q = BN_new();
diff --git a/src/enpass_fmt_plug.c b/src/enpass_fmt_plug.c
index 268bca35a4..35d02bffab 100644
--- a/src/enpass_fmt_plug.c
+++ b/src/enpass_fmt_plug.c
@@ -19,9 +19,6 @@ john_register_one(&fmt_enpass);
 
 #ifdef _OPENMP
 #include <omp.h>
-#ifndef OMP_SCALE
-#define OMP_SCALE               4 // this is a slow format, so 4 should be enough
-#endif
 #endif
 
 #include "aes.h"
@@ -53,10 +50,14 @@ john_register_one(&fmt_enpass);
 #define SALT_ALIGN           sizeof(unsigned int)
 #ifdef SIMD_COEF_32
 #define MIN_KEYS_PER_CRYPT   SSE_GROUP_SZ_SHA1
-#define MAX_KEYS_PER_CRYPT   SSE_GROUP_SZ_SHA1
+#define MAX_KEYS_PER_CRYPT   4 * SSE_GROUP_SZ_SHA1
 #else
 #define MIN_KEYS_PER_CRYPT   1
-#define MAX_KEYS_PER_CRYPT   1
+#define MAX_KEYS_PER_CRYPT   4
+#endif
+
+#ifndef OMP_SCALE
+#define OMP_SCALE            1 // MKPC and scale tuned for i7
 #endif
 
 #define FILE_HEADER_SZ       16
@@ -74,9 +75,8 @@ static struct custom_salt *cur_salt;
 
 static void init(struct fmt_main *self)
 {
-#ifdef _OPENMP
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	saved_key = mem_calloc(sizeof(*saved_key), self->params.max_keys_per_crypt);
 	cracked = mem_calloc(sizeof(*cracked), self->params.max_keys_per_crypt);
 }
@@ -100,8 +100,8 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 #ifdef _OPENMP
 #pragma omp parallel for
 #endif
-	for (index = 0; index < count; index += MAX_KEYS_PER_CRYPT) {
-		unsigned char master[MAX_KEYS_PER_CRYPT][32];
+	for (index = 0; index < count; index += MIN_KEYS_PER_CRYPT) {
+		unsigned char master[MIN_KEYS_PER_CRYPT][32];
 		unsigned char output[24];
 		unsigned char *iv_in;
 		unsigned char iv_out[16];
@@ -109,20 +109,20 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 		AES_KEY akey;
 
 #ifdef SIMD_COEF_32
-		int len[MAX_KEYS_PER_CRYPT];
-		unsigned char *pin[MAX_KEYS_PER_CRYPT], *pout[MAX_KEYS_PER_CRYPT];
-		for (i = 0; i < MAX_KEYS_PER_CRYPT; ++i) {
+		int len[MIN_KEYS_PER_CRYPT];
+		unsigned char *pin[MIN_KEYS_PER_CRYPT], *pout[MIN_KEYS_PER_CRYPT];
+		for (i = 0; i < MIN_KEYS_PER_CRYPT; ++i) {
 			len[i] = strlen(saved_key[i+index]);
 			pin[i] = (unsigned char*)saved_key[i+index];
 			pout[i] = master[i];
 		}
 		pbkdf2_sha1_sse((const unsigned char **)pin, len, cur_salt->salt, 16, cur_salt->iterations, pout, 32, 0);
 #else
-		for (i = 0; i < MAX_KEYS_PER_CRYPT; ++i)
+		for (i = 0; i < MIN_KEYS_PER_CRYPT; ++i)
 			pbkdf2_sha1((unsigned char *)saved_key[index+i], strlen(saved_key[index+i]),
 				cur_salt->salt, 16, cur_salt->iterations, master[i], 32, 0);
 #endif
-		for (i = 0; i < MAX_KEYS_PER_CRYPT; ++i) {
+		for (i = 0; i < MIN_KEYS_PER_CRYPT; ++i) {
 			// memcpy(output, SQLITE_FILE_HEADER, FILE_HEADER_SZ);
 			// See "sqlcipher_page_cipher" and "sqlite3Codec" functions
 			size = page_sz - reserve_sz;
diff --git a/src/fvde_fmt_plug.c b/src/fvde_fmt_plug.c
index 888159f750..6a8b1f8c89 100644
--- a/src/fvde_fmt_plug.c
+++ b/src/fvde_fmt_plug.c
@@ -21,9 +21,6 @@ john_register_one(&fmt_fvde);
 
 #ifdef _OPENMP
 #include <omp.h>
-#ifndef OMP_SCALE
-#define OMP_SCALE               8
-#endif
 #endif
 
 #include "arch.h"
@@ -56,6 +53,11 @@ john_register_one(&fmt_fvde);
 #define SALT_SIZE               sizeof(*cur_salt)
 #define BINARY_ALIGN            1
 #define SALT_ALIGN              sizeof(uint64_t)
+
+#ifndef OMP_SCALE
+#define OMP_SCALE               1 // MKPC and scale tuned for i7
+#endif
+
 #ifdef SIMD_COEF_32
 #define MIN_KEYS_PER_CRYPT      SSE_GROUP_SZ_SHA256
 #define MAX_KEYS_PER_CRYPT      SSE_GROUP_SZ_SHA256
@@ -70,9 +72,8 @@ static fvde_custom_salt *cur_salt;
 
 static void init(struct fmt_main *self)
 {
-#if defined (_OPENMP)
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	saved_key = mem_calloc(sizeof(*saved_key),  self->params.max_keys_per_crypt);
 	cracked = mem_calloc(sizeof(*cracked), self->params.max_keys_per_crypt);
 	cracked_count = self->params.max_keys_per_crypt;
@@ -169,23 +170,23 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 #ifdef _OPENMP
 #pragma omp parallel for
 #endif
-	for (index = 0; index < count; index += MAX_KEYS_PER_CRYPT) {
-		unsigned char master[MAX_KEYS_PER_CRYPT][32];
+	for (index = 0; index < count; index += MIN_KEYS_PER_CRYPT) {
+		unsigned char master[MIN_KEYS_PER_CRYPT][32];
 		int i;
 #ifdef SIMD_COEF_32
-		int lens[MAX_KEYS_PER_CRYPT];
-		unsigned char *pin[MAX_KEYS_PER_CRYPT], *pout[MAX_KEYS_PER_CRYPT];
-		for (i = 0; i < MAX_KEYS_PER_CRYPT; ++i) {
+		int lens[MIN_KEYS_PER_CRYPT];
+		unsigned char *pin[MIN_KEYS_PER_CRYPT], *pout[MIN_KEYS_PER_CRYPT];
+		for (i = 0; i < MIN_KEYS_PER_CRYPT; ++i) {
 			lens[i] = strlen(saved_key[index+i]);
 			pin[i] = (unsigned char*)saved_key[index+i];
 			pout[i] = master[i];
 		}
 		pbkdf2_sha256_sse((const unsigned char**)pin, lens, cur_salt->salt, cur_salt->salt_length, cur_salt->iterations, pout, outlen, 0);
 #else
-		for (i = 0; i < MAX_KEYS_PER_CRYPT; ++i)
+		for (i = 0; i < MIN_KEYS_PER_CRYPT; ++i)
 			pbkdf2_sha256((unsigned char *)saved_key[index+i], strlen(saved_key[index+i]), cur_salt->salt, cur_salt->salt_length, cur_salt->iterations, master[i], outlen, 0);
 #endif
-		for (i = 0; i < MAX_KEYS_PER_CRYPT; ++i) {
+		for (i = 0; i < MIN_KEYS_PER_CRYPT; ++i) {
 			cracked[index+i] = fvde_decrypt(cur_salt, master[i]);
 		}
 	}
diff --git a/src/gpg_fmt_plug.c b/src/gpg_fmt_plug.c
index c75e1548e8..5dfd4cc1e9 100644
--- a/src/gpg_fmt_plug.c
+++ b/src/gpg_fmt_plug.c
@@ -35,9 +35,6 @@ john_register_one(&fmt_gpg);
 
 #ifdef _OPENMP
 #include <omp.h>
-#ifndef OMP_SCALE
-#define OMP_SCALE           64
-#endif
 #endif
 
 #include "arch.h"
@@ -58,6 +55,10 @@ john_register_one(&fmt_gpg);
 #define ALGORITHM_NAME      "32/" ARCH_BITS_STR
 #define SALT_SIZE           sizeof(struct gpg_common_custom_salt*)
 
+#ifndef OMP_SCALE
+#define OMP_SCALE           1 // MKPC and scale tuned for i7
+#endif
+
 #define MIN_KEYS_PER_CRYPT  1
 #define MAX_KEYS_PER_CRYPT  1
 
@@ -68,9 +69,8 @@ static size_t cracked_size;
 
 static void init(struct fmt_main *self)
 {
-#if defined (_OPENMP)
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	saved_key = mem_calloc_align(sizeof(*saved_key),
 			self->params.max_keys_per_crypt, MEM_ALIGN_WORD);
 	any_cracked = 0;
diff --git a/src/haval_fmt_plug.c b/src/haval_fmt_plug.c
index 2cabe8f9d1..f8cec8587a 100644
--- a/src/haval_fmt_plug.c
+++ b/src/haval_fmt_plug.c
@@ -25,23 +25,6 @@ john_register_one(&fmt_haval_128_4);
 
 #ifdef _OPENMP
 #include <omp.h>
-// Tuned on core i7 quad HT
-//       256-3  128-4
-//   1   227k   228k
-//  64  6359k  5489k
-// 128  7953k  6654k
-// 256  8923k  7618k
-// 512  9804k  8223k
-// 1k  10307k  8569k  ** set to this value
-// 2k  10081k  8427k
-// 4k  10551k  8893k
-#ifndef OMP_SCALE
-#ifdef __MIC__
-#define OMP_SCALE  64
-#else
-#define OMP_SCALE  1024
-#endif // __MIC__
-#endif // OMP_SCALE
 #endif // _OPENMP
 
 #include "arch.h"
@@ -64,7 +47,15 @@ john_register_one(&fmt_haval_128_4);
 #define BINARY_ALIGN		4
 #define SALT_ALIGN		1
 #define MIN_KEYS_PER_CRYPT	1
-#define MAX_KEYS_PER_CRYPT	1
+#define MAX_KEYS_PER_CRYPT	64
+
+#ifndef OMP_SCALE
+#ifdef __MIC__
+#define OMP_SCALE  4
+#else
+#define OMP_SCALE  16
+#endif // __MIC__
+#endif // OMP_SCALE
 
 static struct fmt_tests haval_256_3_tests[] = {
 	{"91850C6487C9829E791FC5B58E98E372F3063256BB7D313A93F1F83B426AEDCC", "HAVAL"},
@@ -97,9 +88,8 @@ static uint32_t (*crypt_out)[BINARY_SIZE256 / sizeof(uint32_t)];
 
 static void init(struct fmt_main *self)
 {
-#ifdef _OPENMP
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	if (!saved_key) {
 		saved_key = mem_calloc(self->params.max_keys_per_crypt,
 		                       sizeof(*saved_key));
diff --git a/src/iwork_fmt_plug.c b/src/iwork_fmt_plug.c
index ef5deab08f..775e11cc23 100644
--- a/src/iwork_fmt_plug.c
+++ b/src/iwork_fmt_plug.c
@@ -24,9 +24,6 @@ john_register_one(&fmt_iwork);
 
 #ifdef _OPENMP
 #include <omp.h>
-#ifndef OMP_SCALE
-#define OMP_SCALE               64
-#endif
 #endif
 
 #include "arch.h"
@@ -53,6 +50,11 @@ john_register_one(&fmt_iwork);
 #define SALT_SIZE               sizeof(*fctx)
 #define BINARY_ALIGN            1
 #define SALT_ALIGN              sizeof(int)
+
+#ifndef OMP_SCALE
+#define OMP_SCALE               4
+#endif
+
 #ifdef SIMD_COEF_32
 #define MIN_KEYS_PER_CRYPT      SSE_GROUP_SZ_SHA1
 #define MAX_KEYS_PER_CRYPT      SSE_GROUP_SZ_SHA1
@@ -67,9 +69,8 @@ static struct format_context *fctx;
 
 static void init(struct fmt_main *self)
 {
-#if defined (_OPENMP)
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	saved_key = mem_calloc(sizeof(*saved_key),  self->params.max_keys_per_crypt);
 	cracked = mem_calloc(sizeof(*cracked), self->params.max_keys_per_crypt);
 	cracked_count = self->params.max_keys_per_crypt;
@@ -126,23 +127,23 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 #ifdef _OPENMP
 #pragma omp parallel for
 #endif
-	for (index = 0; index < count; index += MAX_KEYS_PER_CRYPT) {
-		unsigned char master[MAX_KEYS_PER_CRYPT][16];
+	for (index = 0; index < count; index += MIN_KEYS_PER_CRYPT) {
+		unsigned char master[MIN_KEYS_PER_CRYPT][16];
 		int i;
 #ifdef SIMD_COEF_32
-		int lens[MAX_KEYS_PER_CRYPT];
-		unsigned char *pin[MAX_KEYS_PER_CRYPT], *pout[MAX_KEYS_PER_CRYPT];
-		for (i = 0; i < MAX_KEYS_PER_CRYPT; ++i) {
+		int lens[MIN_KEYS_PER_CRYPT];
+		unsigned char *pin[MIN_KEYS_PER_CRYPT], *pout[MIN_KEYS_PER_CRYPT];
+		for (i = 0; i < MIN_KEYS_PER_CRYPT; ++i) {
 			lens[i] = strlen(saved_key[index+i]);
 			pin[i] = (unsigned char*)saved_key[index+i];
 			pout[i] = master[i];
 		}
 		pbkdf2_sha1_sse((const unsigned char**)pin, lens, fctx->salt, fctx->salt_length, fctx->iterations, pout, 16, 0);
 #else
-		for (i = 0; i < MAX_KEYS_PER_CRYPT; ++i)
+		for (i = 0; i < MIN_KEYS_PER_CRYPT; ++i)
 			pbkdf2_sha1((unsigned char *)saved_key[index+i], strlen(saved_key[index+i]), fctx->salt, fctx->salt_length, fctx->iterations, master[i], 16, 0);
 #endif
-		for (i = 0; i < MAX_KEYS_PER_CRYPT; ++i) {
+		for (i = 0; i < MIN_KEYS_PER_CRYPT; ++i) {
 			cracked[index+i] = iwork_decrypt(fctx, master[i], fctx->iv, fctx->blob);
 		}
 	}
diff --git a/src/keychain_fmt_plug.c b/src/keychain_fmt_plug.c
index 69c7b13cbb..99d9235c37 100644
--- a/src/keychain_fmt_plug.c
+++ b/src/keychain_fmt_plug.c
@@ -25,9 +25,6 @@ john_register_one(&fmt_keychain);
 
 #ifdef _OPENMP
 #include <omp.h>
-#ifndef OMP_SCALE
-#define OMP_SCALE               64
-#endif
 #endif
 
 #include "arch.h"
@@ -55,6 +52,11 @@ john_register_one(&fmt_keychain);
 #define SALT_SIZE               sizeof(*cur_salt)
 #define BINARY_ALIGN            1
 #define SALT_ALIGN              1
+
+#ifndef OMP_SCALE
+#define OMP_SCALE               16
+#endif
+
 #ifdef SIMD_COEF_32
 #define MIN_KEYS_PER_CRYPT      SSE_GROUP_SZ_SHA1
 #define MAX_KEYS_PER_CRYPT      SSE_GROUP_SZ_SHA1
@@ -70,9 +72,9 @@ static struct custom_salt *cur_salt;
 
 static void init(struct fmt_main *self)
 {
-#if defined (_OPENMP)
+
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	saved_key = mem_calloc(sizeof(*saved_key),  self->params.max_keys_per_crypt);
 	cracked = mem_calloc(sizeof(*cracked), self->params.max_keys_per_crypt);
 }
@@ -117,17 +119,18 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 {
 	const int count = *pcount;
 	int index;
+
 #ifdef _OPENMP
 #pragma omp parallel for
 #endif
-	for (index = 0; index < count; index += MAX_KEYS_PER_CRYPT) {
-		unsigned char master[MAX_KEYS_PER_CRYPT][32];
+	for (index = 0; index < count; index += MIN_KEYS_PER_CRYPT) {
+		unsigned char master[MIN_KEYS_PER_CRYPT][32];
 		int i;
 #ifdef SIMD_COEF_32
-		int lens[MAX_KEYS_PER_CRYPT];
-		unsigned char *pin[MAX_KEYS_PER_CRYPT], *pout[MAX_KEYS_PER_CRYPT];
+		int lens[MIN_KEYS_PER_CRYPT];
+		unsigned char *pin[MIN_KEYS_PER_CRYPT], *pout[MIN_KEYS_PER_CRYPT];
 
-		for (i = 0; i < MAX_KEYS_PER_CRYPT; ++i) {
+		for (i = 0; i < MIN_KEYS_PER_CRYPT; ++i) {
 			lens[i] = strlen(saved_key[index+i]);
 			pin[i] = (unsigned char*)saved_key[index+i];
 			pout[i] = master[i];
@@ -136,7 +139,7 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 #else
 		pbkdf2_sha1((unsigned char *)saved_key[index],  strlen(saved_key[index]), cur_salt->salt, SALTLEN, 1000, master[0], 24, 0);
 #endif
-		for (i = 0; i < MAX_KEYS_PER_CRYPT; ++i) {
+		for (i = 0; i < MIN_KEYS_PER_CRYPT; ++i) {
 			if (kcdecrypt(master[i], cur_salt->iv, cur_salt->ct) == 0)
 				cracked[index+i] = 1;
 			else
diff --git a/src/keystore_fmt_plug.c b/src/keystore_fmt_plug.c
index 7ae2c1777d..971fc56e2b 100644
--- a/src/keystore_fmt_plug.c
+++ b/src/keystore_fmt_plug.c
@@ -23,6 +23,10 @@ john_register_one(&fmt_keystore);
 
 #include <string.h>
 
+#ifdef _OPENMP
+#include <omp.h>
+#endif
+
 #include "arch.h"
 #include "simd-intrinsics.h"
 #include "sha.h"
@@ -35,19 +39,6 @@ john_register_one(&fmt_keystore);
 #include "johnswap.h"
 #include "keystore_common.h"
 
-#ifdef _OPENMP
-#include <omp.h>
-#ifndef OMP_SCALE
-#if SIMD_COEF_32
-#define OMP_SCALE               1024
-#else
-#define OMP_SCALE               64
-#endif
-#endif
-#elif SIMD_COEF_32
-#define OMP_SCALE               128
-#endif
-
 #ifdef SIMD_COEF_32
 #define NBKEYS                  (SIMD_COEF_32 * SIMD_PARA_SHA1)
 #endif
@@ -65,12 +56,17 @@ john_register_one(&fmt_keystore);
 #define PLAINTEXT_LENGTH        125
 #define SALT_SIZE               sizeof(struct keystore_salt *)
 #define SALT_ALIGN              sizeof(struct keystore_salt *)
+
+#ifndef OMP_SCALE
+#define OMP_SCALE               128 // MKPC and i7 tuned for i7
+#endif
+
 #ifdef SIMD_COEF_32
 #define MIN_KEYS_PER_CRYPT      NBKEYS
-#define MAX_KEYS_PER_CRYPT      NBKEYS
+#define MAX_KEYS_PER_CRYPT      (64 * NBKEYS)
 #else
 #define MIN_KEYS_PER_CRYPT      1
-#define MAX_KEYS_PER_CRYPT      1
+#define MAX_KEYS_PER_CRYPT      64
 #endif
 
 static char (*saved_key)[PLAINTEXT_LENGTH + 1];
@@ -144,16 +140,15 @@ inline static void getPreKeyedHash(int idx)
 
 static void init(struct fmt_main *self)
 {
-#ifdef _OPENMP
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	// We need 1 more saved_key than is 'used'. This extra key is used
 	// in SIMD code, for all part full grouped blocks.
 	saved_key = mem_calloc(sizeof(*saved_key), self->params.max_keys_per_crypt + 1);
 	saved_len = mem_calloc(sizeof(*saved_len), self->params.max_keys_per_crypt + 1);
 	crypt_out = mem_calloc(sizeof(*crypt_out), self->params.max_keys_per_crypt);
 	saved_ctx = mem_calloc(sizeof(*saved_ctx), self->params.max_keys_per_crypt);
-	MixOrderLen = self->params.max_keys_per_crypt*MAX_KEYS_PER_CRYPT+MAX_KEYS_PER_CRYPT;
+	MixOrderLen = self->params.max_keys_per_crypt*MIN_KEYS_PER_CRYPT+MIN_KEYS_PER_CRYPT;
 	MixOrder = mem_calloc(MixOrderLen, sizeof(int));
 }
 
@@ -343,7 +338,7 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 				++tot;
 			}
 		}
-		while (tot_todo % MAX_KEYS_PER_CRYPT)
+		while (tot_todo % MIN_KEYS_PER_CRYPT)
 			MixOrder[tot_todo++] = count;
 	}
 	if (tot < count) {
@@ -354,7 +349,7 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 				++tot;
 				// we only want to do ONE password CTX mode
 				// per loop through the thread.
-				tot_todo += MAX_KEYS_PER_CRYPT;
+				tot_todo += MIN_KEYS_PER_CRYPT;
 			}
 		}
 	}
@@ -368,11 +363,11 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 #ifdef _OPENMP
 #pragma omp parallel for
 #endif
-	for (index = 0; index < tot_todo; index += MAX_KEYS_PER_CRYPT) {
+	for (index = 0; index < tot_todo; index += MIN_KEYS_PER_CRYPT) {
 		SHA_CTX ctx;
 #ifdef SIMD_COEF_32
 		int x, tid=0, len, idx;
-		char tmp_sse_out[20*MAX_KEYS_PER_CRYPT+MEM_ALIGN_SIMD];
+		char tmp_sse_out[20*MIN_KEYS_PER_CRYPT+MEM_ALIGN_SIMD];
 		uint32_t *sse_out;
 		sse_out = (uint32_t *)mem_align(tmp_sse_out, MEM_ALIGN_SIMD);
 #ifdef _OPENMP
@@ -382,7 +377,7 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 		if (len >= 4 && len <= 24) {
 			unsigned char *po;
 			po = (unsigned char*)cursimd->first_blk[tid][len-4];
-			for (x = 0; x < MAX_KEYS_PER_CRYPT; ++x) {
+			for (x = 0; x < MIN_KEYS_PER_CRYPT; ++x) {
 				int j;
 				unsigned char *p;
 				idx = MixOrder[index+x];
@@ -394,12 +389,12 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 			po = (unsigned char*)cursimd->ex_data[len-4];
 			for (x = 0; x < cursimd->n_ex[len-4]; ++x) {
 				SIMDSHA1body(po, sse_out, sse_out, SSEi_MIXED_IN|SSEi_RELOAD);
-				po += 64*MAX_KEYS_PER_CRYPT;
+				po += 64*MIN_KEYS_PER_CRYPT;
 			}
 #ifdef SIMD_COEF_32
 			// we have to 'marshal' the data back into the SIMD output buf.
 			// but we only marshal the first 4 bytes.
-			for (x = 0; x <  MAX_KEYS_PER_CRYPT; ++x) {
+			for (x = 0; x <  MIN_KEYS_PER_CRYPT; ++x) {
 				idx = MixOrder[index+x];
 				if (idx < count)
 #if ARCH_LITTLE_ENDIAN==1
diff --git a/src/lastpass_cli_fmt_plug.c b/src/lastpass_cli_fmt_plug.c
index 07ef815008..4665bba31c 100644
--- a/src/lastpass_cli_fmt_plug.c
+++ b/src/lastpass_cli_fmt_plug.c
@@ -15,11 +15,9 @@ john_register_one(&fmt_lastpass_cli);
 #else
 
 #include <string.h>
+
 #ifdef _OPENMP
 #include <omp.h>
-#ifndef OMP_SCALE
-#define OMP_SCALE              1
-#endif
 #endif
 
 #include "arch.h"
@@ -49,6 +47,11 @@ john_register_one(&fmt_lastpass_cli);
 #define SALT_SIZE               sizeof(struct custom_salt)
 #define BINARY_ALIGN            sizeof(uint32_t)
 #define SALT_ALIGN              sizeof(int)
+
+#ifndef OMP_SCALE
+#define OMP_SCALE              1 // MKPC and scale tuned for i7
+#endif
+
 #ifdef SIMD_COEF_32
 #define MIN_KEYS_PER_CRYPT      SSE_GROUP_SZ_SHA256
 #define MAX_KEYS_PER_CRYPT      SSE_GROUP_SZ_SHA256
@@ -64,9 +67,8 @@ static struct custom_salt *cur_salt;
 
 static void init(struct fmt_main *self)
 {
-#if defined (_OPENMP)
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	saved_key = mem_calloc(sizeof(*saved_key), self->params.max_keys_per_crypt);
 	crypt_out = mem_calloc(sizeof(*crypt_out), self->params.max_keys_per_crypt);
 }
@@ -91,19 +93,19 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 #ifdef _OPENMP
 #pragma omp parallel for
 #endif
-	for (index = 0; index < count; index += MAX_KEYS_PER_CRYPT) {
-		uint32_t key[MAX_KEYS_PER_CRYPT][8];
+	for (index = 0; index < count; index += MIN_KEYS_PER_CRYPT) {
+		uint32_t key[MIN_KEYS_PER_CRYPT][8];
 		int i;
 
 		if (cur_salt->iterations != 1) {
 #ifdef SIMD_COEF_32
-			int lens[MAX_KEYS_PER_CRYPT];
-			unsigned char *pin[MAX_KEYS_PER_CRYPT];
+			int lens[MIN_KEYS_PER_CRYPT];
+			unsigned char *pin[MIN_KEYS_PER_CRYPT];
 			union {
-				uint32_t *pout[MAX_KEYS_PER_CRYPT];
+				uint32_t *pout[MIN_KEYS_PER_CRYPT];
 				unsigned char *poutc;
 			} x;
-			for (i = 0; i < MAX_KEYS_PER_CRYPT; ++i) {
+			for (i = 0; i < MIN_KEYS_PER_CRYPT; ++i) {
 				lens[i] = strlen(saved_key[i+index]);
 				pin[i] = (unsigned char*)saved_key[i+index];
 				x.pout[i] = key[i];
@@ -111,12 +113,12 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 			pbkdf2_sha256_sse((const unsigned char **)pin, lens, cur_salt->salt, cur_salt->salt_length, cur_salt->iterations, &(x.poutc), 32, 0);
 
 #else
-			for (i = 0; i < MAX_KEYS_PER_CRYPT; ++i) {
+			for (i = 0; i < MIN_KEYS_PER_CRYPT; ++i) {
 				pbkdf2_sha256((unsigned char*)saved_key[i+index], strlen(saved_key[i+index]), cur_salt->salt, cur_salt->salt_length, cur_salt->iterations, (unsigned char*)key[i], 32, 0);
 			}
 #endif
 		} else {
-			for (i = 0; i < MAX_KEYS_PER_CRYPT; ++i) {
+			for (i = 0; i < MIN_KEYS_PER_CRYPT; ++i) {
 				SHA256_CTX ctx;
 
 				SHA256_Init(&ctx);
@@ -125,7 +127,7 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 				SHA256_Final((unsigned char*)key[i], &ctx);
 			}
 		}
-		for (i = 0; i < MAX_KEYS_PER_CRYPT; ++i) {
+		for (i = 0; i < MIN_KEYS_PER_CRYPT; ++i) {
 			unsigned char iv[16];
 			AES_KEY akey;
 
diff --git a/src/lastpass_sniffed_fmt_plug.c b/src/lastpass_sniffed_fmt_plug.c
index f7c24bdf5d..c7d4afa0b7 100644
--- a/src/lastpass_sniffed_fmt_plug.c
+++ b/src/lastpass_sniffed_fmt_plug.c
@@ -23,9 +23,6 @@ john_register_one(&fmt_sniffed_lastpass);
 
 #ifdef _OPENMP
 #include <omp.h>
-#ifndef OMP_SCALE
-#define OMP_SCALE               64
-#endif
 #endif
 
 #include "arch.h"
@@ -55,12 +52,17 @@ john_register_one(&fmt_sniffed_lastpass);
 #define SALT_SIZE               sizeof(struct custom_salt)
 #define BINARY_ALIGN            4
 #define SALT_ALIGN              sizeof(int)
+
+#ifndef OMP_SCALE
+#define OMP_SCALE               2 // MKPC and scale tuned for i7
+#endif
+
 #ifdef SIMD_COEF_32
 #define MIN_KEYS_PER_CRYPT      SSE_GROUP_SZ_SHA256
-#define MAX_KEYS_PER_CRYPT      SSE_GROUP_SZ_SHA256
+#define MAX_KEYS_PER_CRYPT      (16 * SSE_GROUP_SZ_SHA256)
 #else
 #define MIN_KEYS_PER_CRYPT      1
-#define MAX_KEYS_PER_CRYPT      1
+#define MAX_KEYS_PER_CRYPT      16
 #endif
 
 /* sentms=1352643586902&xml=2&username=hackme%40mailinator.com&method=cr&hash=4c11d8717015d92db74c42bc1a2570abea3fa18ab17e58a51ce885ee217ccc3f&version=2.0.15&encrypted_username=i%2BhJCwPOj5eQN4tvHcMguoejx4VEmiqzOXOdWIsZKlk%3D&uuid=aHnPh8%40NdhSTWZ%40GJ2fEZe%24cF%40kdzdYh&lang=en-US&iterations=500&sessonly=0&otp=&sesameotp=&multifactorresponse=&lostpwotphash=07a286341be484fc3b96c176e611b10f4d74f230c516f944a008f960f4ec8870&requesthash=i%2BhJCwPOj5eQN4tvHcMguoejx4VEmiqzOXOdWIsZKlk%3D&requestsrc=cr&encuser=i%2BhJCwPOj5eQN4tvHcMguoejx4VEmiqzOXOdWIsZKlk%3D&hasplugin=2.0.15
@@ -89,9 +91,8 @@ static struct custom_salt {
 
 static void init(struct fmt_main *self)
 {
-#ifdef _OPENMP
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	saved_key = mem_calloc(self->params.max_keys_per_crypt,
 	                       sizeof(*saved_key));
 	crypt_key = mem_calloc(self->params.max_keys_per_crypt,
@@ -181,17 +182,17 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 #ifdef _OPENMP
 #pragma omp parallel for
 #endif
-	for (index = 0; index < count; index += MAX_KEYS_PER_CRYPT) {
-		uint32_t key[MAX_KEYS_PER_CRYPT][8];
+	for (index = 0; index < count; index += MIN_KEYS_PER_CRYPT) {
+		uint32_t key[MIN_KEYS_PER_CRYPT][8];
 		unsigned i;
 #ifdef SIMD_COEF_32
-		int lens[MAX_KEYS_PER_CRYPT];
-		unsigned char *pin[MAX_KEYS_PER_CRYPT];
+		int lens[MIN_KEYS_PER_CRYPT];
+		unsigned char *pin[MIN_KEYS_PER_CRYPT];
 		union {
-			uint32_t *pout[MAX_KEYS_PER_CRYPT];
+			uint32_t *pout[MIN_KEYS_PER_CRYPT];
 			unsigned char *poutc;
 		} x;
-		for (i = 0; i < MAX_KEYS_PER_CRYPT; ++i) {
+		for (i = 0; i < MIN_KEYS_PER_CRYPT; ++i) {
 			lens[i] = strlen(saved_key[i+index]);
 			pin[i] = (unsigned char*)saved_key[i+index];
 			x.pout[i] = key[i];
@@ -200,7 +201,7 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 #else
 		pbkdf2_sha256((unsigned char*)saved_key[index], strlen(saved_key[index]), (unsigned char*)cur_salt->username, strlen(cur_salt->username), cur_salt->iterations, (unsigned char*)(&key[0]),32,0);
 #endif
-		for (i = 0; i < MAX_KEYS_PER_CRYPT; ++i) {
+		for (i = 0; i < MIN_KEYS_PER_CRYPT; ++i) {
 			unsigned char *Key = (unsigned char*)key[i];
 			AES_KEY akey;
 			unsigned char iv[16];
diff --git a/src/leet_cc_fmt_plug.c b/src/leet_cc_fmt_plug.c
index 581a79ac21..23cd434653 100644
--- a/src/leet_cc_fmt_plug.c
+++ b/src/leet_cc_fmt_plug.c
@@ -36,6 +36,10 @@ john_register_one(&fmt_leet);
 #include "sph_whirlpool.h"
 #endif
 
+#ifdef _OPENMP
+#include <omp.h>
+#endif
+
 #include "sha2.h"
 #include "misc.h"
 #include "common.h"
@@ -43,23 +47,6 @@ john_register_one(&fmt_leet);
 #include "params.h"
 #include "options.h"
 #include "johnswap.h"
-
-//#undef SIMD_COEF_64
-//#undef SIMD_PARA_SHA512
-
-#ifdef _OPENMP
-#ifdef SIMD_COEF_64
-#ifndef OMP_SCALE
-#define OMP_SCALE               256
-#endif
-#else
-#ifndef OMP_SCALE
-#define OMP_SCALE               128 // tuned on Core i7-6600U
-#endif
-#endif
-#include <omp.h>
-#endif
-
 #include "simd-intrinsics.h"
 
 #ifdef SIMD_COEF_64
@@ -87,8 +74,13 @@ john_register_one(&fmt_leet);
 #define SALT_SIZE               sizeof(struct custom_salt)
 #define BINARY_ALIGN            sizeof(uint64_t)
 #define SALT_ALIGN              sizeof(int)
+
+#ifndef OMP_SCALE
+#define OMP_SCALE               128
+#endif
+
 #define MIN_KEYS_PER_CRYPT      NBKEYS
-#define MAX_KEYS_PER_CRYPT      NBKEYS
+#define MAX_KEYS_PER_CRYPT      (64 * NBKEYS)
 
 static struct fmt_tests leet_tests[] = {
 	{"salt$f86036a85e3ff84e73bf10769011ecdbccbf5aaed9df0240310776b42f5bb8776e612ab15a78bbfc39e867448a08337d97427e182e72922bbaa903ee75b2bfd4", "password"},
@@ -111,9 +103,8 @@ static void init(struct fmt_main *self)
 {
 	int keys;
 
-#ifdef _OPENMP
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	keys = self->params.max_keys_per_crypt;
 	saved_key = mem_calloc(sizeof(*saved_key), keys);
 	saved_len = mem_calloc(keys, sizeof(*saved_len));
@@ -242,12 +233,12 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 #ifdef SIMD_COEF_64
 		// Not sure why JTR_ALIGN(MEM_ALIGN_SIMD) does n ot work here
 		// but if used, it cores travis-ci, so we use mem_align instead
-		unsigned char _in[8*16*MAX_KEYS_PER_CRYPT+MEM_ALIGN_SIMD];
-		unsigned char _out[8*8*MAX_KEYS_PER_CRYPT+MEM_ALIGN_SIMD];
+		unsigned char _in[8*16*MIN_KEYS_PER_CRYPT+MEM_ALIGN_SIMD];
+		unsigned char _out[8*8*MIN_KEYS_PER_CRYPT+MEM_ALIGN_SIMD];
 		uint64_t *in = (uint64_t*)mem_align(_in, MEM_ALIGN_SIMD);
 		uint64_t *out = (uint64_t*)mem_align(_out, MEM_ALIGN_SIMD);
 
-		for (i = 0; i < MAX_KEYS_PER_CRYPT; ++i) {
+		for (i = 0; i < MIN_KEYS_PER_CRYPT; ++i) {
 			int x80_off = saved_len[index+i]+cur_salt->saltlen;
 			unsigned char *cp = (unsigned char*)&(in[16*i]);
 			memcpy(cp, saved_key[index+i], saved_len[index+i]);
@@ -257,7 +248,7 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 			in[i*16+15] = x80_off<<3;
 		}
 		SIMDSHA512body(in, out, NULL, SSEi_FLAT_IN);
-		for (i = 0; i < MAX_KEYS_PER_CRYPT; ++i) {
+		for (i = 0; i < MIN_KEYS_PER_CRYPT; ++i) {
 #if ARCH_LITTLE_ENDIAN==1
 			output1[i].p64[0] = JOHNSWAP64(out[((i/SIMD_COEF_64)*8*SIMD_COEF_64+i%SIMD_COEF_64)]);
 #else
diff --git a/src/lotus5_fmt_plug.c b/src/lotus5_fmt_plug.c
index 9cdea5647e..38ff5eeb1a 100644
--- a/src/lotus5_fmt_plug.c
+++ b/src/lotus5_fmt_plug.c
@@ -11,17 +11,14 @@ john_register_one(&fmt_lotus5);
 
 #include <stdio.h>
 #include <string.h>
-#include "misc.h"
-#include "formats.h"
-#include "common.h"
+
 #ifdef _OPENMP
 #include <omp.h>
 #endif
 
-#ifndef OMP_SCALE
-#define OMP_SCALE 2 // core i7
-#endif
-
+#include "misc.h"
+#include "formats.h"
+#include "common.h"
 
 #ifdef __x86_64__
 #define LOTUS_N 3
@@ -45,7 +42,11 @@ john_register_one(&fmt_lotus5);
 #define SALT_ALIGN				1
 #define MIN_KEYS_PER_CRYPT             LOTUS_N
 /* Must be divisible by any LOTUS_N (thus, by 2 and 3) */
-#define MAX_KEYS_PER_CRYPT             0x900
+#define MAX_KEYS_PER_CRYPT             (64 * LOTUS_N)
+
+#ifndef OMP_SCALE
+#define OMP_SCALE               16 // MKPC and scale tuned for i7
+#endif
 
 /*A struct used for JTR's benchmarks*/
 static struct fmt_tests tests[] = {
@@ -104,9 +105,7 @@ static char (*saved_key)[PLAINTEXT_LENGTH + 1];
 
 static void init(struct fmt_main *self)
 {
-#ifdef _OPENMP
 	omp_autotune(self, OMP_SCALE);
-#endif
 
 	crypt_key = mem_calloc_align(sizeof(*crypt_key),
 	    self->params.max_keys_per_crypt, MEM_ALIGN_CACHE);
diff --git a/src/luks_fmt_plug.c b/src/luks_fmt_plug.c
index 77e19ffa0a..b40dbe8b8c 100644
--- a/src/luks_fmt_plug.c
+++ b/src/luks_fmt_plug.c
@@ -38,9 +38,6 @@ john_register_one(&fmt_luks);
 
 #ifdef _OPENMP
 #include <omp.h>
-#ifndef OMP_SCALE
-#define OMP_SCALE               1
-#endif
 #endif
 
 #include "arch.h"
@@ -86,6 +83,11 @@ john_register_one(&fmt_luks);
 #define BINARY_ALIGN        4
 #define SALT_SIZE           sizeof(struct custom_salt_LUKS*)
 #define SALT_ALIGN          sizeof(struct custom_salt_LUKS*)
+
+#ifndef OMP_SCALE
+#define OMP_SCALE               1 // MKPC and scale tuned for i7
+#endif
+
 #if SIMD_COEF_32
 #define MIN_KEYS_PER_CRYPT  SSE_GROUP_SZ_SHA1
 #define MAX_KEYS_PER_CRYPT  SSE_GROUP_SZ_SHA1
@@ -284,9 +286,8 @@ static void init(struct fmt_main *self)
 {
 	static int warned = 0;
 
-#ifdef _OPENMP
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	saved_key = mem_calloc(sizeof(*saved_key), self->params.max_keys_per_crypt);
 	crypt_out = mem_calloc(sizeof(*crypt_out), self->params.max_keys_per_crypt);
 
@@ -538,21 +539,21 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 #ifdef _OPENMP
 #pragma omp parallel for
 #endif
-	for (index = 0; index < count; index += MAX_KEYS_PER_CRYPT) {
+	for (index = 0; index < count; index += MIN_KEYS_PER_CRYPT) {
 		unsigned char *af_decrypted = (unsigned char *)mem_alloc(cur_salt->afsize + 20);
 		int i, iterations = cur_salt->bestiter;
 		int dklen = john_ntohl(cur_salt->myphdr.keyBytes);
-		uint32_t keycandidate[MAX_KEYS_PER_CRYPT][256/4];
-		uint32_t masterkeycandidate[MAX_KEYS_PER_CRYPT][256/4];
+		uint32_t keycandidate[MIN_KEYS_PER_CRYPT][256/4];
+		uint32_t masterkeycandidate[MIN_KEYS_PER_CRYPT][256/4];
 #ifdef SIMD_COEF_32
-		int lens[MAX_KEYS_PER_CRYPT];
-		unsigned char *pin[MAX_KEYS_PER_CRYPT];
+		int lens[MIN_KEYS_PER_CRYPT];
+		unsigned char *pin[MIN_KEYS_PER_CRYPT];
 		union {
-			uint32_t *pout[MAX_KEYS_PER_CRYPT];
+			uint32_t *pout[MIN_KEYS_PER_CRYPT];
 			unsigned char *poutc;
 		} x;
 
-		for (i = 0; i < MAX_KEYS_PER_CRYPT; ++i) {
+		for (i = 0; i < MIN_KEYS_PER_CRYPT; ++i) {
 			lens[i] = strlen(saved_key[index+i]);
 			pin[i] = (unsigned char*)saved_key[index+i];
 			x.pout[i] = keycandidate[i];
@@ -566,7 +567,7 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 		            (const unsigned char*)(cur_salt->myphdr.keyblock[cur_salt->bestslot].passwordSalt), LUKS_SALTSIZE,
 		            iterations, (unsigned char*)keycandidate[0], dklen, 0);
 #endif
-		for (i = 0; i < MAX_KEYS_PER_CRYPT; ++i) {
+		for (i = 0; i < MIN_KEYS_PER_CRYPT; ++i) {
 			// Decrypt the blocksi
 			decrypt_aes_cbc_essiv(cur_salt->cipherbuf, af_decrypted, (unsigned char*)keycandidate[i], cur_salt->afsize, cur_salt);
 			// AFMerge the blocks
@@ -575,7 +576,7 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 		}
 		// pbkdf2 again
 #ifdef SIMD_COEF_32
-		for (i = 0; i < MAX_KEYS_PER_CRYPT; ++i) {
+		for (i = 0; i < MIN_KEYS_PER_CRYPT; ++i) {
 			lens[i] = john_ntohl(cur_salt->myphdr.keyBytes);
 			pin[i] = (unsigned char*)masterkeycandidate[i];
 			x.pout[i] = crypt_out[index+i];
diff --git a/src/mongodb_scram_fmt_plug.c b/src/mongodb_scram_fmt_plug.c
index ead2dd4fb4..a5d29260e8 100644
--- a/src/mongodb_scram_fmt_plug.c
+++ b/src/mongodb_scram_fmt_plug.c
@@ -14,6 +14,11 @@ john_register_one(&fmt_mongodb_scram);
 
 #include <openssl/sha.h>
 #include <string.h>
+
+#ifdef _OPENMP
+#include <omp.h>
+#endif
+
 #include "arch.h"
 #include "misc.h"
 #include "memory.h"
@@ -24,15 +29,8 @@ john_register_one(&fmt_mongodb_scram);
 #include "base64_convert.h"
 #include "hmac_sha.h"
 #include "simd-intrinsics.h"
-//#undef SIMD_COEF_32
 #include "pbkdf2_hmac_sha1.h"
 #include "md5.h"
-#ifdef _OPENMP
-#include <omp.h>
-#ifndef OMP_SCALE
-#define OMP_SCALE               1
-#endif
-#endif
 
 #if defined SIMD_COEF_32
 #define SIMD_KEYS		(SIMD_COEF_32 * SIMD_PARA_SHA1)
@@ -49,16 +47,21 @@ john_register_one(&fmt_mongodb_scram);
 #define BINARY_ALIGN            sizeof(uint32_t)
 #define BENCHMARK_COMMENT       ""
 #define BENCHMARK_LENGTH        0x107
+#define FORMAT_TAG              "$scram$"
+#define FORMAT_TAG_LENGTH       (sizeof(FORMAT_TAG) - 1)
+#define MAX_USERNAME_LENGTH     128
+
+#ifndef OMP_SCALE
+#define OMP_SCALE               1 // MKPC and scale tuned for i7
+#endif
+
 #if !defined(SIMD_COEF_32)
 #define MIN_KEYS_PER_CRYPT      1
-#define MAX_KEYS_PER_CRYPT      1
+#define MAX_KEYS_PER_CRYPT      64
 #else
-#define MIN_KEYS_PER_CRYPT	SIMD_KEYS
-#define MAX_KEYS_PER_CRYPT	SIMD_KEYS
+#define MIN_KEYS_PER_CRYPT      SIMD_KEYS
+#define MAX_KEYS_PER_CRYPT      (64 * SIMD_KEYS)
 #endif
-#define FORMAT_TAG              "$scram$"
-#define FORMAT_TAG_LENGTH       (sizeof(FORMAT_TAG) - 1)
-#define MAX_USERNAME_LENGTH     128
 
 static struct fmt_tests tests[] = {
 	{"$scram$someadmin$10000$wf42AF7JaU1NSeBaSmkKzw==$H6A5RF0qz6DrcWNNX4xe+wIeVEw=", "secret"},
@@ -78,9 +81,8 @@ static uint32_t (*crypt_out)[BINARY_SIZE / sizeof(uint32_t)];
 
 static void init(struct fmt_main *self)
 {
-#ifdef _OPENMP
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	saved_key = mem_calloc(self->params.max_keys_per_crypt,
 			sizeof(*saved_key));
 	crypt_out = mem_calloc(self->params.max_keys_per_crypt,
@@ -187,7 +189,7 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 #ifdef _OPENMP
 #pragma omp parallel for
 #endif
-	for (index = 0; index < count; index += MAX_KEYS_PER_CRYPT) {
+	for (index = 0; index < count; index += MIN_KEYS_PER_CRYPT) {
 #if !defined (SIMD_COEF_32)
 		SHA_CTX ctx;
 		MD5_CTX mctx;
diff --git a/src/multibit_fmt_plug.c b/src/multibit_fmt_plug.c
index 457d55062b..114673ce49 100644
--- a/src/multibit_fmt_plug.c
+++ b/src/multibit_fmt_plug.c
@@ -20,9 +20,6 @@ john_register_one(&fmt_multibit);
 
 #ifdef _OPENMP
 #include <omp.h>
-#ifndef OMP_SCALE
-#define OMP_SCALE               2
-#endif
 #endif
 
 #include "arch.h"
@@ -50,7 +47,11 @@ john_register_one(&fmt_multibit);
 #define SALT_ALIGN              sizeof(uint32_t)
 #define PLAINTEXT_LENGTH        125
 #define MIN_KEYS_PER_CRYPT      1
-#define MAX_KEYS_PER_CRYPT      4
+#define MAX_KEYS_PER_CRYPT      1
+
+#ifndef OMP_SCALE
+#define OMP_SCALE               4 // MKPC and scale tuned for i7
+#endif
 
 static struct fmt_tests multibit_tests[] = {
 	// Wallets created by MultiBit Classic 0.5.18
@@ -86,9 +87,8 @@ static struct custom_salt {
 
 static void init(struct fmt_main *self)
 {
-#ifdef _OPENMP
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	saved_key = mem_calloc(sizeof(*saved_key), self->params.max_keys_per_crypt);
 	cracked = mem_calloc(sizeof(*cracked), self->params.max_keys_per_crypt);
 	cracked_count = self->params.max_keys_per_crypt;
diff --git a/src/nukedclan_fmt_plug.c b/src/nukedclan_fmt_plug.c
index 2372256022..2dbccbc134 100644
--- a/src/nukedclan_fmt_plug.c
+++ b/src/nukedclan_fmt_plug.c
@@ -24,6 +24,10 @@ john_register_one(&fmt_nk);
 
 #include <string.h>
 
+#ifdef _OPENMP
+#include <omp.h>
+#endif
+
 #include "arch.h"
 #include "md5.h"
 #include "sha.h"
@@ -33,20 +37,6 @@ john_register_one(&fmt_nk);
 #include "params.h"
 #include "options.h"
 
-#ifdef _OPENMP
-#include <omp.h>
-// Tuned on core i7 quad HT
-//   1  5059K
-//  16  8507k
-//  64  8907k   ** this was chosen.
-// 128  8914k
-// 256  8810k
-#ifndef OMP_SCALE
-#define OMP_SCALE    64
-#endif
-#endif
-
-
 #define FORMAT_LABEL		"nk"
 #define FORMAT_NAME		"Nuked-Klan CMS"
 #define FORMAT_TAG		"$nk$*"
@@ -61,7 +51,11 @@ john_register_one(&fmt_nk);
 #define BINARY_ALIGN		sizeof(uint32_t)
 #define SALT_ALIGN			sizeof(int)
 #define MIN_KEYS_PER_CRYPT	1
-#define MAX_KEYS_PER_CRYPT	64
+#define MAX_KEYS_PER_CRYPT	256
+
+#ifndef OMP_SCALE
+#define OMP_SCALE			128 // MKPC and scale tuned for i7
+#endif
 
 static struct fmt_tests nk_tests[] = {
 	{"$nk$*379637b4fcde21b2c5fbc9a00af505e997443267*#17737d3661312121d5ae7d5c6156c0298", "openwall"},
@@ -94,9 +88,8 @@ inline static void hex_encode(unsigned char *str, int len, unsigned char *out)
 
 static void init(struct fmt_main *self)
 {
-#ifdef _OPENMP
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	saved_key = mem_calloc(sizeof(*saved_key), self->params.max_keys_per_crypt);
 	crypt_out = mem_calloc(sizeof(*crypt_out), self->params.max_keys_per_crypt);
 }
diff --git a/src/o3logon_fmt_plug.c b/src/o3logon_fmt_plug.c
index a2d6a57f10..677bfc6b9b 100644
--- a/src/o3logon_fmt_plug.c
+++ b/src/o3logon_fmt_plug.c
@@ -21,6 +21,10 @@ john_register_one(&fmt_o3logon);
 #include <string.h>
 #include <openssl/des.h>
 
+#ifdef _OPENMP
+#include <omp.h>
+#endif
+
 #include "arch.h"
 #include "misc.h"
 #include "common.h"
@@ -28,13 +32,6 @@ john_register_one(&fmt_o3logon);
 #include "sha.h"
 #include "unicode.h"
 #include "base64_convert.h"
-#ifdef _OPENMP
-#include <omp.h>
-#ifndef OMP_SCALE
-#define OMP_SCALE               512 // tuned on core i7
-//#define OMP_SCALE                8192 // tuned on K8-Dual HT
-#endif
-#endif
 
 
 #define FORMAT_LABEL                    "o3logon"
@@ -54,10 +51,14 @@ john_register_one(&fmt_o3logon);
 #define SALT_SIZE                       (sizeof(ora9_salt))
 #define SALT_ALIGN                      (sizeof(unsigned int))
 #define CIPHERTEXT_LENGTH               16
+#define MAX_HASH_LEN                    (FORMAT_TAG_LEN+MAX_USERNAME_LEN+1+32+1+80)
 
 #define MIN_KEYS_PER_CRYPT		1
-#define MAX_KEYS_PER_CRYPT		1
-#define MAX_HASH_LEN                    (FORMAT_TAG_LEN+MAX_USERNAME_LEN+1+32+1+80)
+#define MAX_KEYS_PER_CRYPT		64
+
+#ifndef OMP_SCALE
+#define OMP_SCALE               128 // MKPC and scale tuned for i7
+#endif
 
 
 //#define DEBUG_ORACLE
@@ -90,9 +91,8 @@ static DES_key_schedule desschedule1;	// key 0x0123456789abcdef
 
 static void init(struct fmt_main *self)
 {
-#ifdef _OPENMP
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	DES_set_key((DES_cblock *)"\x01\x23\x45\x67\x89\xab\xcd\xef", &desschedule1);
 	cur_key = mem_calloc(self->params.max_keys_per_crypt,
 	                       sizeof(*cur_key));
diff --git a/src/office_fmt_plug.c b/src/office_fmt_plug.c
index 0b328504e7..71077adabe 100644
--- a/src/office_fmt_plug.c
+++ b/src/office_fmt_plug.c
@@ -15,9 +15,6 @@ john_register_one(&fmt_office);
 
 #ifdef _OPENMP
 #include <omp.h>
-#ifndef OMP_SCALE
-#define OMP_SCALE                4
-#endif
 #endif
 
 #include "arch.h"
@@ -67,6 +64,10 @@ john_register_one(&fmt_office);
 #define MAX_KEYS_PER_CRYPT       1
 #endif
 
+#ifndef OMP_SCALE
+#define OMP_SCALE                1 // MKPC and scale tuned for i7
+#endif
+
 static struct fmt_tests office_tests[] = {
 	{"$office$*2007*20*128*16*8b2c9e8c878844fc842012273be4bea8*aa862168b80d8c45c852696a8bb499eb*a413507fabe2d87606595f987f679ff4b5b4c2cd", "Password"},
 	/* 2007-Default_myhovercraftisfullofeels_.docx */
@@ -586,9 +587,8 @@ static void GenerateAgileEncryptionKey512(int idx, unsigned char hashBuf[SHA512_
 
 static void init(struct fmt_main *self)
 {
-#if defined (_OPENMP)
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	saved_key = mem_calloc(sizeof(*saved_key), self->params.max_keys_per_crypt);
 	saved_len = mem_calloc(sizeof(*saved_len), self->params.max_keys_per_crypt);
 	crypt_key = mem_calloc(sizeof(*crypt_key), self->params.max_keys_per_crypt);
diff --git a/src/openbsdsoftraid_fmt_plug.c b/src/openbsdsoftraid_fmt_plug.c
index ff48432f9e..625210c77d 100644
--- a/src/openbsdsoftraid_fmt_plug.c
+++ b/src/openbsdsoftraid_fmt_plug.c
@@ -26,9 +26,6 @@ john_register_one(&fmt_openbsd_softraid);
 
 #ifdef _OPENMP
 #include <omp.h>
-#ifndef OMP_SCALE
-#define OMP_SCALE                   1
-#endif
 #endif
 
 #include "arch.h"
@@ -63,6 +60,10 @@ john_register_one(&fmt_openbsd_softraid);
 #define MAX_KEYS_PER_CRYPT          1
 #endif
 
+#ifndef OMP_SCALE
+#define OMP_SCALE                   1 // MKPC and scale tuned for i7
+#endif
+
 static char (*key_buffer)[PLAINTEXT_LENGTH + 1];
 static uint32_t (*crypt_out)[BINARY_SIZE / sizeof(uint32_t)];
 
@@ -70,9 +71,8 @@ static struct custom_salt *cur_salt;
 
 static void init(struct fmt_main *self)
 {
-#ifdef _OPENMP
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	key_buffer = mem_calloc(sizeof(*key_buffer), self->params.max_keys_per_crypt);
 	crypt_out = mem_calloc(sizeof(*crypt_out), self->params.max_keys_per_crypt);
 }
@@ -100,9 +100,9 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 #ifdef _OPENMP
 #pragma omp parallel for
 #endif
-	for (index = 0; index < count; index += MAX_KEYS_PER_CRYPT) {
+	for (index = 0; index < count; index += MIN_KEYS_PER_CRYPT) {
 		AES_KEY akey;
-		unsigned char mask_key[MAX_KEYS_PER_CRYPT][32];
+		unsigned char mask_key[MIN_KEYS_PER_CRYPT][32];
 		unsigned char unmasked_keys[OPENBSD_SOFTRAID_KEYLENGTH * OPENBSD_SOFTRAID_KEYS];
 		unsigned char hashed_mask_key[20];
 		int i, j;
@@ -122,7 +122,7 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 					cur_salt->num_iterations, (unsigned char**)pout,
 					32, 0);
 #else
-			for (i = 0; i < MAX_KEYS_PER_CRYPT; ++i) {
+			for (i = 0; i < MIN_KEYS_PER_CRYPT; ++i) {
 				pbkdf2_sha1((const unsigned char*)(key_buffer[index+i]),
 						strlen(key_buffer[index+i]),
 						cur_salt->salt, OPENBSD_SOFTRAID_SALTLENGTH,
@@ -131,7 +131,7 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 			}
 #endif
 		} else if (cur_salt->kdf_type == 3) {
-			for (i = 0; i < MAX_KEYS_PER_CRYPT; ++i) {
+			for (i = 0; i < MIN_KEYS_PER_CRYPT; ++i) {
 				bcrypt_pbkdf((const char*)key_buffer[index+i],
 						strlen(key_buffer[index+i]),
 						cur_salt->salt, OPENBSD_SOFTRAID_SALTLENGTH,
@@ -139,7 +139,7 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 			}
 		}
 
-		for (i = 0; i < MAX_KEYS_PER_CRYPT; ++i) {
+		for (i = 0; i < MIN_KEYS_PER_CRYPT; ++i) {
 			/* decrypt sector keys */
 			AES_set_decrypt_key(mask_key[i], 256, &akey);
 			for (j = 0; j < (OPENBSD_SOFTRAID_KEYLENGTH * OPENBSD_SOFTRAID_KEYS) / 16;  j++) {
diff --git a/src/openssl_enc_fmt_plug.c b/src/openssl_enc_fmt_plug.c
index e0303b408f..251ce1ab78 100644
--- a/src/openssl_enc_fmt_plug.c
+++ b/src/openssl_enc_fmt_plug.c
@@ -44,9 +44,6 @@ john_register_one(&fmt_openssl);
 
 #ifdef _OPENMP
 #include <omp.h>
-#ifndef OMP_SCALE
-#define OMP_SCALE               8
-#endif
 #endif
 
 #include "aes.h"
@@ -69,11 +66,15 @@ john_register_one(&fmt_openssl);
 #define SALT_SIZE           sizeof(struct custom_salt)
 #define BINARY_ALIGN        1
 #define SALT_ALIGN          sizeof(int)
-#define MIN_KEYS_PER_CRYPT  8
-#define MAX_KEYS_PER_CRYPT  8
 #define PLAINTEXT_LENGTH    125
 #define FORMAT_TAG          "$openssl$"
 #define TAG_LENGTH          (sizeof(FORMAT_TAG) - 1)
+#define MIN_KEYS_PER_CRYPT  1
+#define MAX_KEYS_PER_CRYPT  64
+
+#ifndef OMP_SCALE
+#define OMP_SCALE           2
+#endif
 
 static char (*saved_key)[PLAINTEXT_LENGTH + 1];
 static int *cracked;
@@ -106,9 +107,8 @@ static struct fmt_tests tests[] = {
 
 static void init(struct fmt_main *self)
 {
-#if defined (_OPENMP)
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	saved_key = mem_calloc(self->params.max_keys_per_crypt,
 	                       sizeof(*saved_key));
 	cracked = mem_calloc(self->params.max_keys_per_crypt,
diff --git a/src/ospf_fmt_plug.c b/src/ospf_fmt_plug.c
index 1926e2a281..875e78c05d 100644
--- a/src/ospf_fmt_plug.c
+++ b/src/ospf_fmt_plug.c
@@ -22,9 +22,6 @@ john_register_one(&fmt_ospf);
 
 #ifdef _OPENMP
 #include <omp.h>
-#ifndef OMP_SCALE
-#define OMP_SCALE               2048
-#endif
 #endif
 
 #include "formats.h"
@@ -48,9 +45,13 @@ john_register_one(&fmt_ospf);
 #define BINARY_ALIGN            sizeof(uint32_t)
 #define SALT_SIZE               sizeof(struct custom_salt)
 #define SALT_ALIGN              sizeof(uint32_t)
-#define MIN_KEYS_PER_CRYPT      1
-#define MAX_KEYS_PER_CRYPT      1
 #define MAX_SALT_LEN            1500 + 64 // 64 is reserved for appending ospf_apad
+#define MIN_KEYS_PER_CRYPT      1
+#define MAX_KEYS_PER_CRYPT      64
+
+#ifndef OMP_SCALE
+#define OMP_SCALE               128 // MKPC and scale tuned for i7
+#endif
 
 static struct fmt_tests tests[] = {
 	/* ospf*.pcap from https://c0decafe.de/svn/codename_loki/ */
@@ -75,9 +76,8 @@ static struct custom_salt {
 
 static void init(struct fmt_main *self)
 {
-#ifdef _OPENMP
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	saved_key = mem_calloc(sizeof(*saved_key), self->params.max_keys_per_crypt);
 	crypt_out = mem_calloc(sizeof(*crypt_out), self->params.max_keys_per_crypt);
 }
diff --git a/src/palshop_fmt_plug.c b/src/palshop_fmt_plug.c
index 8439e33724..4200febe78 100644
--- a/src/palshop_fmt_plug.c
+++ b/src/palshop_fmt_plug.c
@@ -14,22 +14,21 @@ extern struct fmt_main fmt_palshop;
 john_register_one(&fmt_palshop);
 #else
 
+#include <string.h>
+
+#ifdef _OPENMP
+#include <omp.h>
+#endif
+
 #include "arch.h"
 #include "sha.h"
 #include "md5.h"
-#include <string.h>
 #include "misc.h"
 #include "common.h"
 #include "formats.h"
 #include "params.h"
 #include "options.h"
 #include "base64_convert.h"
-#ifdef _OPENMP
-#include <omp.h>
-#ifndef OMP_SCALE
-#define OMP_SCALE               1024
-#endif
-#endif
 
 #define FORMAT_LABEL            "Palshop"
 #define FORMAT_NAME             "MD5(Palshop)"
@@ -42,11 +41,14 @@ john_register_one(&fmt_palshop);
 #define SALT_SIZE               0
 #define BINARY_ALIGN            sizeof(uint32_t)
 #define SALT_ALIGN              sizeof(int)
-#define MIN_KEYS_PER_CRYPT      1
-#define MAX_KEYS_PER_CRYPT      1
 #define FORMAT_TAG              "$palshop$"
 #define TAG_LENGTH              (sizeof(FORMAT_TAG) - 1)
+#define MIN_KEYS_PER_CRYPT      1
+#define MAX_KEYS_PER_CRYPT      64
 
+#ifndef OMP_SCALE
+#define OMP_SCALE               256
+#endif
 
 static struct fmt_tests palshop_tests[] = {
 	{"$palshop$68b11ee90ed17ef14aa0f51af494c2c63ad7d281a9888cb593e", "123"},
@@ -62,9 +64,8 @@ static size_t *saved_len;
 
 static void init(struct fmt_main *self)
 {
-#ifdef _OPENMP
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	saved_key = mem_calloc(self->params.max_keys_per_crypt,
 			sizeof(*saved_key));
 	crypt_out = mem_calloc(self->params.max_keys_per_crypt,
diff --git a/src/pbkdf2-hmac-md4_fmt_plug.c b/src/pbkdf2-hmac-md4_fmt_plug.c
index 2220150a08..717c30e2c0 100644
--- a/src/pbkdf2-hmac-md4_fmt_plug.c
+++ b/src/pbkdf2-hmac-md4_fmt_plug.c
@@ -14,6 +14,10 @@ john_register_one(&fmt_pbkdf2_hmac_md4);
 #include <string.h>
 #include <stdint.h>
 
+#ifdef _OPENMP
+#include <omp.h>
+#endif
+
 #include "arch.h"
 #include "misc.h"
 #include "common.h"
@@ -21,13 +25,6 @@ john_register_one(&fmt_pbkdf2_hmac_md4);
 #include "pbkdf2_hmac_md4.h"
 #include "pbkdf2_hmac_common.h"
 
-#ifdef _OPENMP
-#include <omp.h>
-#ifndef OMP_SCALE
-#define OMP_SCALE               256
-#endif
-#endif
-
 #define FORMAT_LABEL            "PBKDF2-HMAC-MD4"
 #define FORMAT_NAME             ""
 #ifdef SIMD_COEF_32
@@ -37,14 +34,19 @@ john_register_one(&fmt_pbkdf2_hmac_md4);
 #endif
 #define SALT_SIZE               sizeof(struct custom_salt)
 #define SALT_ALIGN              sizeof(uint32_t)
+#define PLAINTEXT_LENGTH        125
+
 #if SIMD_COEF_32
 #define MIN_KEYS_PER_CRYPT      (SIMD_COEF_32 * SIMD_PARA_MD4)
-#define MAX_KEYS_PER_CRYPT      (SIMD_COEF_32 * SIMD_PARA_MD4)
+#define MAX_KEYS_PER_CRYPT      (64 * SIMD_COEF_32 * SIMD_PARA_MD4)
 #else
 #define MIN_KEYS_PER_CRYPT      1
-#define MAX_KEYS_PER_CRYPT      1
+#define MAX_KEYS_PER_CRYPT      64
+#endif
+
+#ifndef OMP_SCALE
+#define OMP_SCALE               1 // MKPC and scale tuned for i7
 #endif
-#define PLAINTEXT_LENGTH        125
 
 static struct custom_salt {
 	unsigned int length;
@@ -57,9 +59,8 @@ static uint32_t (*crypt_out)[PBKDF2_MDx_BINARY_SIZE / sizeof(uint32_t)];
 
 static void init(struct fmt_main *self)
 {
-#ifdef _OPENMP
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	saved_key = mem_calloc(self->params.max_keys_per_crypt, sizeof(*saved_key));
 	crypt_out = mem_calloc(self->params.max_keys_per_crypt, sizeof(*crypt_out));
 }
@@ -113,7 +114,7 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 #ifdef _OPENMP
 #pragma omp parallel for
 #endif
-	for (index = 0; index < count; index += MAX_KEYS_PER_CRYPT) {
+	for (index = 0; index < count; index += MIN_KEYS_PER_CRYPT) {
 #if SIMD_COEF_32
 		int lens[SSE_GROUP_SZ_MD4], i;
 		unsigned char *pin[SSE_GROUP_SZ_MD4];
diff --git a/src/pbkdf2-hmac-sha1_fmt_plug.c b/src/pbkdf2-hmac-sha1_fmt_plug.c
index e72acdaf0f..ce59743475 100644
--- a/src/pbkdf2-hmac-sha1_fmt_plug.c
+++ b/src/pbkdf2-hmac-sha1_fmt_plug.c
@@ -14,6 +14,10 @@ john_register_one(&fmt_pbkdf2_hmac_sha1);
 #include <string.h>
 #include <stdint.h>
 
+#ifdef _OPENMP
+#include <omp.h>
+#endif
+
 #include "arch.h"
 #include "misc.h"
 #include "common.h"
@@ -23,13 +27,6 @@ john_register_one(&fmt_pbkdf2_hmac_sha1);
 #include "pbkdf2_hmac_sha1.h"
 #include "pbkdf2_hmac_common.h"
 
-#ifdef _OPENMP
-#include <omp.h>
-#ifndef OMP_SCALE
-#define OMP_SCALE               64
-#endif
-#endif
-
 #define FORMAT_LABEL            "PBKDF2-HMAC-SHA1"
 #define FORMAT_NAME             ""
 
@@ -43,12 +40,16 @@ john_register_one(&fmt_pbkdf2_hmac_sha1);
 #define SALT_SIZE               sizeof(struct custom_salt)
 #define SALT_ALIGN              sizeof(uint32_t)
 
+#ifndef OMP_SCALE
+#define OMP_SCALE               1
+#endif
+
 #ifdef SIMD_COEF_32
 #define MIN_KEYS_PER_CRYPT      SSE_GROUP_SZ_SHA1
-#define MAX_KEYS_PER_CRYPT      SSE_GROUP_SZ_SHA1
+#define MAX_KEYS_PER_CRYPT      (8 * SSE_GROUP_SZ_SHA1)
 #else
 #define MIN_KEYS_PER_CRYPT      1
-#define MAX_KEYS_PER_CRYPT      1
+#define MAX_KEYS_PER_CRYPT      8
 #endif
 
 #define PAD_SIZE                64
@@ -67,9 +68,8 @@ static uint32_t (*crypt_out)[PBKDF2_SHA1_BINARY_SIZE / sizeof(uint32_t)];
 
 static void init(struct fmt_main *self)
 {
-#ifdef _OPENMP
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	saved_key = mem_calloc(self->params.max_keys_per_crypt,
 	                       sizeof(*saved_key));
 	crypt_out = mem_calloc(self->params.max_keys_per_crypt,
@@ -123,7 +123,7 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 #ifdef _OPENMP
 #pragma omp parallel for
 #endif
-	for (index = 0; index < count; index += MAX_KEYS_PER_CRYPT) {
+	for (index = 0; index < count; index += MIN_KEYS_PER_CRYPT) {
 #ifdef SSE_GROUP_SZ_SHA1
 		int lens[SSE_GROUP_SZ_SHA1], i;
 		unsigned char *pin[SSE_GROUP_SZ_SHA1];
diff --git a/src/pbkdf2_hmac_sha256_fmt_plug.c b/src/pbkdf2_hmac_sha256_fmt_plug.c
index b466c7e835..c3df679c41 100644
--- a/src/pbkdf2_hmac_sha256_fmt_plug.c
+++ b/src/pbkdf2_hmac_sha256_fmt_plug.c
@@ -27,6 +27,10 @@ john_register_one(&fmt_pbkdf2_hmac_sha256);
 #include <string.h>
 #include <stdint.h>
 
+#ifdef _OPENMP
+#include <omp.h>
+#endif
+
 #include "misc.h"
 #include "arch.h"
 #include "common.h"
@@ -39,6 +43,7 @@ john_register_one(&fmt_pbkdf2_hmac_sha256);
 
 #define FORMAT_LABEL            "PBKDF2-HMAC-SHA256"
 #define FORMAT_NAME		""
+#define BENCHMARK_LENGTH        0x107
 
 #ifdef SIMD_COEF_32
 #define ALGORITHM_NAME		"PBKDF2-SHA256 " SHA256_ALGORITHM_NAME
@@ -53,18 +58,15 @@ john_register_one(&fmt_pbkdf2_hmac_sha256);
 #define MAX_CIPHERTEXT_LENGTH   1024 /* Bump this and code will adopt */
 #define SALT_SIZE               sizeof(struct custom_salt)
 #ifdef SIMD_COEF_32
-#define MIN_KEYS_PER_CRYPT	SSE_GROUP_SZ_SHA256
-#define MAX_KEYS_PER_CRYPT	SSE_GROUP_SZ_SHA256
+#define MIN_KEYS_PER_CRYPT      SSE_GROUP_SZ_SHA256
+#define MAX_KEYS_PER_CRYPT      (4 * SSE_GROUP_SZ_SHA256)
 #else
 #define MIN_KEYS_PER_CRYPT      1
-#define MAX_KEYS_PER_CRYPT      1
+#define MAX_KEYS_PER_CRYPT      4
 #endif
-#define BENCHMARK_LENGTH        0x107
-#ifdef _OPENMP
-#include <omp.h>
+
 #ifndef OMP_SCALE
-#define OMP_SCALE               4
-#endif
+#define OMP_SCALE               2
 #endif
 
 
@@ -82,9 +84,8 @@ static uint32_t (*crypt_out)[PBKDF2_SHA256_BINARY_SIZE / sizeof(uint32_t)];
 
 static void init(struct fmt_main *self)
 {
-#ifdef _OPENMP
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	saved_key = mem_calloc(self->params.max_keys_per_crypt,
 	                       sizeof(*saved_key));
 	crypt_out = mem_calloc(self->params.max_keys_per_crypt,
@@ -136,7 +137,7 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 #ifdef _OPENMP
 #pragma omp parallel for
 #endif
-	for (index = 0; index < count; index += MAX_KEYS_PER_CRYPT) {
+	for (index = 0; index < count; index += MIN_KEYS_PER_CRYPT) {
 #ifdef SSE_GROUP_SZ_SHA256
 		int lens[SSE_GROUP_SZ_SHA256], i;
 		unsigned char *pin[SSE_GROUP_SZ_SHA256];
diff --git a/src/putty_fmt_plug.c b/src/putty_fmt_plug.c
index 485c6e9abc..a8c3bc2428 100644
--- a/src/putty_fmt_plug.c
+++ b/src/putty_fmt_plug.c
@@ -21,9 +21,6 @@ john_register_one(&fmt_putty);
 
 #ifdef _OPENMP
 #include <omp.h>
-#ifndef OMP_SCALE
-#define OMP_SCALE           64
-#endif
 #endif
 
 #include "arch.h"
@@ -49,9 +46,13 @@ john_register_one(&fmt_putty);
 #define SALT_SIZE           sizeof(struct custom_salt)
 #define SALT_ALIGN          4
 #define MIN_KEYS_PER_CRYPT  1
-#define MAX_KEYS_PER_CRYPT  1
+#define MAX_KEYS_PER_CRYPT  64
 
-#define PUT_32BIT_MSB_FIRST(cp, value) ( \
+#ifndef OMP_SCALE
+#define OMP_SCALE           128
+#endif
+
+#define PUT_32BIT_MSB_FIRST(cp, value) (	  \
 		(cp)[0] = (unsigned char)((value) >> 24), \
 		(cp)[1] = (unsigned char)((value) >> 16), \
 		(cp)[2] = (unsigned char)((value) >> 8), \
@@ -87,9 +88,8 @@ static struct fmt_tests putty_tests[] = {
 
 static void init(struct fmt_main *self)
 {
-#if defined (_OPENMP)
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	saved_key = mem_calloc(self->params.max_keys_per_crypt,
 	                       sizeof(*saved_key));
 	any_cracked = 0;
diff --git a/src/qnx_fmt_plug.c b/src/qnx_fmt_plug.c
index 39e96dbdc1..a500195920 100644
--- a/src/qnx_fmt_plug.c
+++ b/src/qnx_fmt_plug.c
@@ -17,14 +17,18 @@ john_register_one(&fmt_qnx);
 
 #include "arch.h"
 
+#define _GNU_SOURCE 1
+#include <string.h>
+
+#ifdef _OPENMP
+#include <omp.h>
+#endif
+
 #undef SIMD_COEF_32
 #define FORCE_GENERIC_SHA2 1
 #include "sha2.h"
 #include "md5.h"
 
-#define _GNU_SOURCE 1
-#include <string.h>
-
 #include "params.h"
 #include "common.h"
 #include "formats.h"
@@ -32,14 +36,6 @@ john_register_one(&fmt_qnx);
 #include "simd-intrinsics.h"
 #include "misc.h"
 
-#ifdef _OPENMP
-#ifndef OMP_SCALE
-#define OMP_SCALE			8
-#endif
-#include <omp.h>
-#endif
-
-
 // NOTE, in SSE mode, even if NOT in OMP, we may need to scale, quite a bit, due to needing
 // to 'group' passwords based upon length of password.
 #ifdef SIMD_COEF_32
@@ -66,10 +62,14 @@ john_register_one(&fmt_qnx);
 
 #ifdef SIMD_COEF_32
 #define MIN_KEYS_PER_CRYPT		(SIMD_COEF_32*SIMD_PARA_SHA256)
-#define MAX_KEYS_PER_CRYPT		(SIMD_COEF_32*SIMD_PARA_SHA256)
+#define MAX_KEYS_PER_CRYPT		(8 * SIMD_COEF_32*SIMD_PARA_SHA256)
 #else
 #define MIN_KEYS_PER_CRYPT		1
-#define MAX_KEYS_PER_CRYPT		1
+#define MAX_KEYS_PER_CRYPT		8
+#endif
+
+#ifndef OMP_SCALE
+#define OMP_SCALE				128
 #endif
 
 #define __QNX_CREATE_PROPER_TESTS_ARRAY__
@@ -96,9 +96,8 @@ static void init(struct fmt_main *self)
 	int sc_threads = 1;
 	int max_crypts;
 
-#ifdef _OPENMP
 	sc_threads = omp_autotune(self, OMP_SCALE);
-#endif
+
 	max_crypts = SIMD_COEF_SCALE * sc_threads * MAX_KEYS_PER_CRYPT;
 	self->params.max_keys_per_crypt = max_crypts;
 	// we allocate 1 more than needed, and use that 'extra' value as a zero
@@ -163,13 +162,13 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 #endif
 	if (usesse) {
 		int j, k;
-		MixOrder = (int*)mem_calloc((count+PLAINTEXT_LENGTH*MAX_KEYS_PER_CRYPT), sizeof(int));
+		MixOrder = (int*)mem_calloc((count+PLAINTEXT_LENGTH*MIN_KEYS_PER_CRYPT), sizeof(int));
 		tot_todo = 0;
 		saved_len[count] = 0; // point all 'tail' MMX buffer elements to this location.
 		for (j = 1; j < PLAINTEXT_LENGTH; ++j) {
 			for (k = 0; k < sk_by_lens[j]; ++k)
 				MixOrder[tot_todo++] = sk_by_len[k];
-			while (tot_todo % MAX_KEYS_PER_CRYPT)
+			while (tot_todo % MIN_KEYS_PER_CRYPT)
 				MixOrder[tot_todo++] = count;
 		}
 	}
diff --git a/src/radmin_fmt_plug.c b/src/radmin_fmt_plug.c
index b147cd5c36..07260a3e48 100644
--- a/src/radmin_fmt_plug.c
+++ b/src/radmin_fmt_plug.c
@@ -20,15 +20,6 @@ john_register_one(&fmt_radmin);
 
 #ifdef _OPENMP
 #include <omp.h>
-// Tuned on core i7 quad HT
-//   1   7445K
-//  16  12155K
-//  32  12470K  ** this was chosen.
-//  64  12608k
-// 128  12508k
-#ifndef OMP_SCALE
-#define OMP_SCALE     32
-#endif
 #endif
 
 #include "md5.h"
@@ -50,11 +41,14 @@ john_register_one(&fmt_radmin);
 #define CIPHERTEXT_LENGTH       32
 #define BINARY_SIZE             16
 #define SALT_SIZE               0
+#define BINARY_ALIGN            4
+#define SALT_ALIGN              1
 #define MIN_KEYS_PER_CRYPT      1
 #define MAX_KEYS_PER_CRYPT      64
 
-#define BINARY_ALIGN            4
-#define SALT_ALIGN              1
+#ifndef OMP_SCALE
+#define OMP_SCALE               8192 // MKPC and scale tuned for i7
+#endif
 
 static struct fmt_tests radmin_tests[] = {
 	{"$radmin2$B137F09CF92F465CABCA06AB1B283C1F", "lastwolf"},
@@ -73,9 +67,8 @@ static uint32_t (*crypt_out)[8];
 
 static void init(struct fmt_main *self)
 {
-#ifdef _OPENMP
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	saved_key = mem_calloc(self->params.max_keys_per_crypt,
 	                       sizeof(*saved_key));
 	crypt_out = mem_calloc(self->params.max_keys_per_crypt,
diff --git a/src/rakp_fmt_plug.c b/src/rakp_fmt_plug.c
index 42db4e77d2..1e6090a814 100644
--- a/src/rakp_fmt_plug.c
+++ b/src/rakp_fmt_plug.c
@@ -14,9 +14,6 @@ john_register_one(&fmt_rakp);
 
 #ifdef _OPENMP
 #include <omp.h>
-#ifndef OMP_SCALE
-#define OMP_SCALE 2048 // tuned for i7 using SSE2 and w/o HT
-#endif
 #endif
 
 #include "arch.h"
@@ -46,9 +43,13 @@ john_register_one(&fmt_rakp);
 #define FORMAT_TAG              "$rakp$"
 #define TAG_LENGTH              (sizeof(FORMAT_TAG) - 1)
 
+#ifndef OMP_SCALE
+#define OMP_SCALE               64
+#endif
+
 #ifdef SIMD_COEF_32
 #define MIN_KEYS_PER_CRYPT      SHA1_N
-#define MAX_KEYS_PER_CRYPT      SHA1_N
+#define MAX_KEYS_PER_CRYPT      (64 * SHA1_N)
 #if ARCH_LITTLE_ENDIAN==1
 #define GETPOS(i, index)        ((index & (SIMD_COEF_32 - 1)) * 4 + ((i) & (0xffffffff - 3)) * SIMD_COEF_32 + (3 - ((i) & 3)) + (unsigned int)index/SIMD_COEF_32 * SHA_BUF_SIZ * 4 * SIMD_COEF_32)
 #else
@@ -56,7 +57,7 @@ john_register_one(&fmt_rakp);
 #endif
 #else
 #define MIN_KEYS_PER_CRYPT      1
-#define MAX_KEYS_PER_CRYPT      1
+#define MAX_KEYS_PER_CRYPT      64
 #endif
 
 static struct fmt_tests tests[] = {
@@ -105,9 +106,9 @@ static void init(struct fmt_main *self)
 #ifdef SIMD_COEF_32
 	int i;
 #endif
-#ifdef _OPENMP
+
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 #ifdef SIMD_COEF_32
 	bufsize = sizeof(*opad) * self->params.max_keys_per_crypt * SHA_BUF_SIZ * 4;
 	crypt_key = mem_calloc_align(1, bufsize, MEM_ALIGN_SIMD);
@@ -340,7 +341,7 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 #if _OPENMP
 #pragma omp parallel for
 #endif
-	for (index = 0; index < count; index += MAX_KEYS_PER_CRYPT) {
+	for (index = 0; index < count; index += MIN_KEYS_PER_CRYPT) {
 #ifdef SIMD_COEF_32
 		if (new_keys) {
 			SIMDSHA1body(&ipad[index * SHA_BUF_SIZ * 4],
diff --git a/src/rawBLAKE2_512_fmt_plug.c b/src/rawBLAKE2_512_fmt_plug.c
index b976ae845c..50f307045e 100644
--- a/src/rawBLAKE2_512_fmt_plug.c
+++ b/src/rawBLAKE2_512_fmt_plug.c
@@ -14,14 +14,7 @@ john_register_one(&fmt_rawBLAKE2);
 
 #include <string.h>
 
-#if !FAST_FORMATS_OMP
-#undef _OPENMP
-#endif
-
 #ifdef _OPENMP
-#ifndef OMP_SCALE
-#define OMP_SCALE               2048
-#endif
 #include <omp.h>
 #endif
 
@@ -57,7 +50,11 @@ john_register_one(&fmt_rawBLAKE2);
 #define BINARY_ALIGN            4
 #define SALT_ALIGN              1
 #define MIN_KEYS_PER_CRYPT      1
-#define MAX_KEYS_PER_CRYPT      1
+#define MAX_KEYS_PER_CRYPT      64
+
+#ifndef OMP_SCALE
+#define OMP_SCALE               512
+#endif
 
 static struct fmt_tests tests[] = {
 	{"4245af08b46fbb290222ab8a68613621d92ce78577152d712467742417ebc1153668f1c9e1ec1e152a32a9c242dc686d175e087906377f0c483c5be2cb68953e", "blake2"},
@@ -79,9 +76,8 @@ static uint32_t (*crypt_out)
 
 static void init(struct fmt_main *self)
 {
-#ifdef _OPENMP
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	saved_len = mem_calloc(self->params.max_keys_per_crypt,
 	                       sizeof(*saved_len));
 	saved_key = mem_calloc(self->params.max_keys_per_crypt,
@@ -206,10 +202,7 @@ struct fmt_main fmt_rawBLAKE2 = {
 		SALT_ALIGN,
 		MIN_KEYS_PER_CRYPT,
 		MAX_KEYS_PER_CRYPT,
-#ifdef _OPENMP
-		FMT_OMP | FMT_OMP_BAD |
-#endif
-		FMT_CASE | FMT_8_BIT | FMT_SPLIT_UNIFIES_CASE,
+		FMT_OMP | FMT_CASE | FMT_8_BIT | FMT_SPLIT_UNIFIES_CASE,
 		{ NULL },
 		{ FORMAT_TAG },
 		tests
diff --git a/src/rawKeccak_256_fmt_plug.c b/src/rawKeccak_256_fmt_plug.c
index 7495a04d2a..56ab2d8fae 100644
--- a/src/rawKeccak_256_fmt_plug.c
+++ b/src/rawKeccak_256_fmt_plug.c
@@ -17,6 +17,10 @@ john_register_one(&fmt_rawKeccak_256);
 
 #include <string.h>
 
+#ifdef _OPENMP
+#include <omp.h>
+#endif
+
 #include "arch.h"
 #include "params.h"
 #include "common.h"
@@ -24,14 +28,6 @@ john_register_one(&fmt_rawKeccak_256);
 #include "options.h"
 #include "KeccakHash.h"
 
-#ifdef _OPENMP
-#ifndef OMP_SCALE
-#define OMP_SCALE			2048
-#endif
-#include <omp.h>
-#endif
-
-
 #define FORMAT_TAG		"$keccak256$"
 #define TAG_LENGTH		(sizeof(FORMAT_TAG)-1)
 
@@ -53,7 +49,11 @@ john_register_one(&fmt_rawKeccak_256);
 #define SALT_ALIGN			1
 
 #define MIN_KEYS_PER_CRYPT		1
-#define MAX_KEYS_PER_CRYPT		1
+#define MAX_KEYS_PER_CRYPT		128
+
+#ifndef OMP_SCALE
+#define OMP_SCALE			32
+#endif
 
 static struct fmt_tests tests[] = {
 	{"4e03657aea45a94fc7d47ba826c8d667c0d1e6e33a64a036ec44f58fa12d6c45", "abc"},
@@ -73,9 +73,8 @@ static uint32_t (*crypt_out)
 
 static void init(struct fmt_main *self)
 {
-#ifdef _OPENMP
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	saved_len = mem_calloc(self->params.max_keys_per_crypt,
 			sizeof(*saved_len));
 	saved_key = mem_calloc(self->params.max_keys_per_crypt,
@@ -194,13 +193,12 @@ struct fmt_main fmt_rawKeccak_256 = {
 		0,
 		PLAINTEXT_LENGTH,
 		BINARY_SIZE,
-                BINARY_ALIGN,
+		BINARY_ALIGN,
 		SALT_SIZE,
-                SALT_ALIGN,
+		SALT_ALIGN,
 		MIN_KEYS_PER_CRYPT,
 		MAX_KEYS_PER_CRYPT,
-		FMT_CASE | FMT_8_BIT | FMT_OMP | FMT_OMP_BAD |
-		FMT_SPLIT_UNIFIES_CASE,
+		FMT_CASE | FMT_8_BIT | FMT_OMP | FMT_SPLIT_UNIFIES_CASE,
 		{ NULL },
 		{ FORMAT_TAG },
 		tests
diff --git a/src/rawSHA256_fmt_plug.c b/src/rawSHA256_fmt_plug.c
index 3da4721e95..cbd6db8a5d 100644
--- a/src/rawSHA256_fmt_plug.c
+++ b/src/rawSHA256_fmt_plug.c
@@ -24,34 +24,21 @@ john_register_one(&fmt_rawSHA256);
 
 #include <stdint.h>
 
+#ifdef _OPENMP
+#include <omp.h>
+#endif
+
 #include "arch.h"
 #include "sha2.h"
 #include "params.h"
 #include "common.h"
 #include "johnswap.h"
 #include "formats.h"
-
-//#undef SIMD_COEF_32
-//#undef SIMD_PARA_SHA256
-
 /*
  * Only effective for SIMD.
  * Undef to disable reversing steps for benchmarking.
  */
 #define REVERSE_STEPS
-
-#ifdef _OPENMP
-#ifdef SIMD_COEF_32
-#ifndef OMP_SCALE
-#define OMP_SCALE               1024
-#endif
-#else
-#ifndef OMP_SCALE
-#define OMP_SCALE               2048
-#endif
-#endif
-#include <omp.h>
-#endif
 #include "simd-intrinsics.h"
 
 #define FORMAT_LABEL            "Raw-SHA256"
@@ -79,10 +66,14 @@ john_register_one(&fmt_rawSHA256);
 
 #ifdef SIMD_COEF_32
 #define MIN_KEYS_PER_CRYPT      (SIMD_COEF_32*SIMD_PARA_SHA256)
-#define MAX_KEYS_PER_CRYPT      (SIMD_COEF_32*SIMD_PARA_SHA256)
+#define MAX_KEYS_PER_CRYPT      (64*SIMD_COEF_32*SIMD_PARA_SHA256)
 #else
 #define MIN_KEYS_PER_CRYPT      1
-#define MAX_KEYS_PER_CRYPT      1
+#define MAX_KEYS_PER_CRYPT      64
+#endif
+
+#ifndef OMP_SCALE
+#define OMP_SCALE               32 // MKPC and scale tuned for i7
 #endif
 
 #ifdef SIMD_COEF_32
@@ -99,9 +90,8 @@ static uint32_t (*crypt_out)
 
 static void init(struct fmt_main *self)
 {
-#ifdef _OPENMP
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 #ifndef SIMD_COEF_32
 	saved_len = mem_calloc(self->params.max_keys_per_crypt,
 	                       sizeof(*saved_len));
@@ -181,7 +171,7 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 #ifdef _OPENMP
 #pragma omp parallel for
 #endif
-	for (index = 0; index < count; index += MAX_KEYS_PER_CRYPT) {
+	for (index = 0; index < count; index += MIN_KEYS_PER_CRYPT) {
 #ifdef SIMD_COEF_32
 		SIMDSHA256body(&saved_key[(unsigned int)index/SIMD_COEF_32*SHA_BUF_SIZ*SIMD_COEF_32],
 		              &crypt_out[(unsigned int)index/SIMD_COEF_32*8*SIMD_COEF_32],
diff --git a/src/rawSHA256_ng_fmt_plug.c b/src/rawSHA256_ng_fmt_plug.c
index 83b182253d..9977eaf674 100644
--- a/src/rawSHA256_ng_fmt_plug.c
+++ b/src/rawSHA256_ng_fmt_plug.c
@@ -16,23 +16,22 @@ extern struct fmt_main fmt_rawSHA256_ng;
 john_register_one(&fmt_rawSHA256_ng);
 #else
 
+#include <string.h>
+#include <stdint.h>
+
 #if !FAST_FORMATS_OMP
 #undef _OPENMP
 #endif
 
 #if _OPENMP
 #include <omp.h>
-#if __XOP__
-#ifndef OMP_SCALE
-#define OMP_SCALE                 512 /* AMD */
-#endif
-#else
-#ifndef OMP_SCALE
-#define OMP_SCALE                 512 /* Intel */
-#endif
-#endif
 #endif
 
+#include "pseudo_intrinsics.h"
+#include "common.h"
+#include "formats.h"
+#include "aligned.h"
+
 #include "misc.h"
 #if !defined(DEBUG) && !defined(WITH_ASAN)
 // These compilers claim to be __GNUC__ but warn on gcc pragmas.
@@ -41,14 +40,6 @@ john_register_one(&fmt_rawSHA256_ng);
 #endif
 #endif
 
-#include <string.h>
-#include <stdint.h>
-
-#include "pseudo_intrinsics.h"
-#include "common.h"
-#include "formats.h"
-#include "aligned.h"
-
 #if __MIC__
 #define SIMD_TYPE                 "512/512 MIC 16x"
 #elif __AVX512F__
@@ -90,7 +81,11 @@ john_register_one(&fmt_rawSHA256_ng);
 #define SALT_SIZE                 0
 #define SALT_ALIGN                1
 #define MIN_KEYS_PER_CRYPT        VWIDTH
-#define MAX_KEYS_PER_CRYPT        VWIDTH
+#define MAX_KEYS_PER_CRYPT        (2 * VWIDTH)
+
+#ifndef OMP_SCALE
+#define OMP_SCALE                 512 // MKPC and scale tuned for i7
+#endif
 
 #if __SSE4_1__ && !__AVX2__
 #undef GATHER
@@ -182,9 +177,8 @@ static void init(struct fmt_main *self)
 {
     int i;
 
-#ifdef _OPENMP
 	omp_autotune(self, OMP_SCALE);
-#endif
+
     saved_key = mem_calloc_align(self->params.max_keys_per_crypt,
                                  sizeof(*saved_key), VWIDTH * 4);
     for (i = 0; i < 8; i++)
diff --git a/src/rawSHA512_fmt_plug.c b/src/rawSHA512_fmt_plug.c
index e645862f9d..6b4876fd12 100644
--- a/src/rawSHA512_fmt_plug.c
+++ b/src/rawSHA512_fmt_plug.c
@@ -22,6 +22,10 @@ john_register_one(&fmt_raw0_SHA512);
 
 #include <stdint.h>
 
+#ifdef _OPENMP
+#include <omp.h>
+#endif
+
 #include "arch.h"
 #include "sha2.h"
 #include "params.h"
@@ -29,28 +33,11 @@ john_register_one(&fmt_raw0_SHA512);
 #include "johnswap.h"
 #include "formats.h"
 #include "rawSHA512_common.h"
-
-//#undef SIMD_COEF_64
-//#undef SIMD_PARA_SHA512
-
 /*
  * Only effective for SIMD.
  * Undef to disable reversing steps for benchmarking.
  */
 #define REVERSE_STEPS
-
-#ifdef _OPENMP
-#ifdef SIMD_COEF_64
-#ifndef OMP_SCALE
-#define OMP_SCALE               1024
-#endif
-#else
-#ifndef OMP_SCALE
-#define OMP_SCALE				2048
-#endif
-#endif
-#include <omp.h>
-#endif
 #include "simd-intrinsics.h"
 
 #define FORMAT_LABEL		"Raw-SHA512"
@@ -75,10 +62,14 @@ john_register_one(&fmt_raw0_SHA512);
 
 #ifdef SIMD_COEF_64
 #define MIN_KEYS_PER_CRYPT		(SIMD_COEF_64*SIMD_PARA_SHA512)
-#define MAX_KEYS_PER_CRYPT      (SIMD_COEF_64*SIMD_PARA_SHA512)
+#define MAX_KEYS_PER_CRYPT      (64*SIMD_COEF_64*SIMD_PARA_SHA512)
 #else
 #define MIN_KEYS_PER_CRYPT		1
-#define MAX_KEYS_PER_CRYPT		1
+#define MAX_KEYS_PER_CRYPT		64
+#endif
+
+#ifndef OMP_SCALE
+#define OMP_SCALE               4 // MKPC and scale tuned for i7
 #endif
 
 #ifdef SIMD_COEF_64
@@ -95,9 +86,8 @@ static uint64_t (*crypt_out)[DIGEST_SIZE / sizeof(uint64_t)];
 
 static void init(struct fmt_main *self)
 {
-#ifdef _OPENMP
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 #ifndef SIMD_COEF_64
 	saved_len = mem_calloc(self->params.max_keys_per_crypt,
 	                       sizeof(*saved_len));
@@ -196,7 +186,7 @@ static int crypt_all(int *pcount, struct db_salt *salt)
 #ifdef _OPENMP
 #pragma omp parallel for
 #endif
-	for (index = 0; index < count; index += MAX_KEYS_PER_CRYPT) {
+	for (index = 0; index < count; index += MIN_KEYS_PER_CRYPT) {
 #ifdef SIMD_COEF_64
 		SIMDSHA512body(&saved_key[index/SIMD_COEF_64*SHA_BUF_SIZ*SIMD_COEF_64],
 		              &crypt_out[index/SIMD_COEF_64*8*SIMD_COEF_64],
diff --git a/src/rawSHA512_ng_fmt_plug.c b/src/rawSHA512_ng_fmt_plug.c
index 4d383e38ed..4de26f8675 100644
--- a/src/rawSHA512_ng_fmt_plug.c
+++ b/src/rawSHA512_ng_fmt_plug.c
@@ -16,20 +16,20 @@ extern struct fmt_main fmt_rawSHA512_ng;
 john_register_one(&fmt_rawSHA512_ng);
 #else
 
+#include <stdint.h>
+#include <string.h>
+
 #if _OPENMP
 #include <omp.h>
-#if __XOP__
-#ifndef OMP_SCALE
-#define OMP_SCALE                 768 /* AMD */
-#endif
-#else
-#ifndef OMP_SCALE
-#define OMP_SCALE                 2048 /* Intel */
-#endif
-#endif
 #endif
 
 #include "misc.h"
+#include "pseudo_intrinsics.h"
+#include "common.h"
+#include "formats.h"
+#include "johnswap.h"
+#include "rawSHA512_common.h"
+
 #if !defined(DEBUG) && !defined(WITH_ASAN)
 // These compilers claim to be __GNUC__ but warn on gcc pragmas.
 #if __GNUC__ && !__INTEL_COMPILER && !__clang__ && !__llvm__ && !_MSC_VER
@@ -37,15 +37,6 @@ john_register_one(&fmt_rawSHA512_ng);
 #endif
 #endif
 
-#include <stdint.h>
-#include <string.h>
-
-#include "pseudo_intrinsics.h"
-#include "common.h"
-#include "formats.h"
-#include "johnswap.h"
-#include "rawSHA512_common.h"
-
 #if __MIC__
 #define SIMD_TYPE                 "512/512 MIC 8x"
 #elif __AVX512F__
@@ -78,14 +69,17 @@ john_register_one(&fmt_rawSHA512_ng);
 
 //#define MAXLEN                    119
 #define MAXLEN                    111
-#define PLAINTEXT_LENGTH	  MAXLEN
+#define PLAINTEXT_LENGTH	      MAXLEN
 #define CIPHERTEXT_LENGTH         128
 #define BINARY_SIZE               8
 #define SALT_SIZE                 0
 #define SALT_ALIGN                1
 #define MIN_KEYS_PER_CRYPT        VWIDTH
-#define MAX_KEYS_PER_CRYPT        VWIDTH
+#define MAX_KEYS_PER_CRYPT        (64 * VWIDTH)
 
+#ifndef OMP_SCALE
+#define OMP_SCALE                 64
+#endif
 
 #undef GATHER /* This one is not like the shared ones in pseudo_intrinsics.h */
 
@@ -188,9 +182,9 @@ static uint64_t *crypt_key[ 8];
 static void init(struct fmt_main *self)
 {
     int i;
-#ifdef _OPENMP
+
 	omp_autotune(self, OMP_SCALE);
-#endif
+
     saved_key = mem_calloc_align(self->params.max_keys_per_crypt,
                            sizeof(*saved_key), MEM_ALIGN_SIMD);
     for (i = 0; i < 8; i++)
@@ -426,11 +420,7 @@ static int cmp_all(void *binary, int count)
 {
     int i;
 
-#ifdef _OPENMP
     for (i=0; i < count; i++)
-#else
-    for (i=0; i < VWIDTH; i++)
-#endif
         if (((uint64_t *) binary)[0] == crypt_key[0][i])
             return 1;
 
diff --git a/src/sapH_fmt_plug.c b/src/sapH_fmt_plug.c
index 387714ebe7..1f9d1f5c4a 100644
--- a/src/sapH_fmt_plug.c
+++ b/src/sapH_fmt_plug.c
@@ -26,16 +26,11 @@ john_register_one(&fmt_sapH);
 #include <string.h>
 #include <ctype.h>
 
-#include "arch.h"
-/* for now, undef this until I get OMP working, then start on SIMD */
-//#undef _OPENMP
-//#undef SIMD_COEF_32
-//#undef SIMD_PARA_SHA1
-//#undef SIMD_COEF_32
-//#undef SIMD_PARA_SHA256
-//#undef SIMD_COEF_64
-//#undef SIMD_PARA_SHA512
+#if defined(_OPENMP)
+#include <omp.h>
+#endif
 
+#include "arch.h"
 #include "misc.h"
 #include "common.h"
 #include "formats.h"
@@ -44,19 +39,6 @@ john_register_one(&fmt_sapH);
 #include "sha2.h"
 #include "johnswap.h"
 
-#if defined(_OPENMP)
-#include <omp.h>
-#ifdef SIMD_COEF_32
-#ifndef OMP_SCALE
-#define OMP_SCALE			8
-#endif
-#else
-#ifndef OMP_SCALE
-#define OMP_SCALE			64
-#endif
-#endif
-#endif
-
 /*
  * Assumption is made that SIMD_COEF_32*SIMD_PARA_SHA1 is >= than
  * SHA256_COEF*PARA and SHA512_COEF*PARA, and that these other 2
@@ -120,14 +102,18 @@ john_register_one(&fmt_sapH);
 /* NOTE, format is slow enough that endianity conversion is pointless. Just use flat buffers. */
 #ifdef SIMD_COEF_32
 #define MIN_KEYS_PER_CRYPT		NBKEYS
-#define MAX_KEYS_PER_CRYPT		NBKEYS
+#define MAX_KEYS_PER_CRYPT		(8 * NBKEYS)
 #define PLAINTEXT_LENGTH        23 /* Real world max. is 40 */
 #else
 #define MIN_KEYS_PER_CRYPT		1
-#define MAX_KEYS_PER_CRYPT		1
+#define MAX_KEYS_PER_CRYPT		8
 #define PLAINTEXT_LENGTH        40
 #endif
 
+#ifndef OMP_SCALE
+#define OMP_SCALE               2
+#endif
+
 static struct fmt_tests tests[] = {
 	/* first 2 hashes are 'default' 1024 iteration with 12 bytes salt so */
 	/* timings reflect that, and benchmark comment set to (sha1, 1024) */
@@ -163,9 +149,8 @@ static struct sapH_salt {
 
 static void init(struct fmt_main *self)
 {
-#if defined (_OPENMP)
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	saved_plain = mem_calloc(self->params.max_keys_per_crypt,
 	                         sizeof(*saved_plain));
 	crypt_key   = mem_calloc(self->params.max_keys_per_crypt,
diff --git a/src/siemens-s7_fmt_plug.c b/src/siemens-s7_fmt_plug.c
index d112d4fea9..32657ea198 100644
--- a/src/siemens-s7_fmt_plug.c
+++ b/src/siemens-s7_fmt_plug.c
@@ -19,9 +19,6 @@ john_register_one(&fmt_s7);
 
 #ifdef _OPENMP
 #include <omp.h>
-#ifndef OMP_SCALE
-#define OMP_SCALE               2048
-#endif
 #endif
 
 #include "sha.h"
@@ -46,7 +43,11 @@ john_register_one(&fmt_s7);
 #define BINARY_ALIGN            sizeof(uint32_t)
 #define SALT_ALIGN              1
 #define MIN_KEYS_PER_CRYPT      1
-#define MAX_KEYS_PER_CRYPT      8
+#define MAX_KEYS_PER_CRYPT      64
+
+#ifndef OMP_SCALE
+#define OMP_SCALE               4
+#endif
 
 static struct fmt_tests s7_tests[] = {
 	{"$siemens-s7$1$599fe00cdb61f76cc6e949162f22c95943468acb$002e45951f62602b2f5d15df217f49da2f5379cb", "123"},
@@ -64,9 +65,8 @@ unsigned char *challenge;
 
 static void init(struct fmt_main *self)
 {
-#ifdef _OPENMP
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	saved_key = mem_calloc(self->params.max_keys_per_crypt,
 	                       sizeof(*saved_key));
 	crypt_out = mem_calloc(self->params.max_keys_per_crypt,
diff --git a/src/sip_fmt_plug.c b/src/sip_fmt_plug.c
index f537556555..5482c172cd 100644
--- a/src/sip_fmt_plug.c
+++ b/src/sip_fmt_plug.c
@@ -20,15 +20,6 @@ john_register_one(&fmt_sip);
 
 #ifdef _OPENMP
 #include <omp.h>
-// Tuned on core i7 quad HT
-//   1   4963K
-//  16   8486K
-//  32   8730K  ** this was chosen.
-//  64   8791k
-// 128   8908k
-#ifndef OMP_SCALE
-#define OMP_SCALE   32
-#endif
 #endif
 
 #include "arch.h"
@@ -64,6 +55,10 @@ static sip_salt *pSalt;
 #define MIN_KEYS_PER_CRYPT      1
 #define MAX_KEYS_PER_CRYPT      64
 
+#ifndef OMP_SCALE
+#define OMP_SCALE   512 // MKPC & scale tuned for i7
+#endif
+
 static struct fmt_tests sip_tests[] = {
 	{"$sip$*192.168.1.111*192.168.1.104*200*asterisk*REGISTER*sip*192.168.1.104**46cce857****MD5*4dfc7515936a667565228dbaa0293dfc", "123456"},
 	{"$sip$*10.0.1.20*10.0.1.10*1001*asterisk*REGISTER*sips*10.0.1.20*5061*0ef95b07****MD5*576e39e9de6a9ed053eb218f65fe470e", "q1XCLF0KaBObo797"},
@@ -83,9 +78,8 @@ static char bin2hex_table[256][2]; /* table for bin<->hex mapping */
 
 static void init(struct fmt_main *self)
 {
-#ifdef _OPENMP
 	omp_autotune(self, OMP_SCALE);
-#endif
+
 	/* Init bin 2 hex table for faster conversions later */
 	init_bin2hex(bin2hex_table);
 	saved_key = mem_calloc(self->params.max_keys_per_crypt,
